/*********************************************************************************\
*     File:                  C R O P . C P P                                      *
*                                                                                 *
*     Standard   C++                                                              *
*                                                                                 *
\*********************************************************************************/
/*
 * crop.cpp: algoritms to get a subimage from a image
 *
 *  Contains:
 *         void CropPic();
 */

#include "ImgBasic.h"
#include <time.h>


/*********************************************************************************/
void ImgBasic::CropPic(void)
{
  byte* newpic;
  char buf[128];         /* Buffer for user input                */
  int sx,sy,sw,sh;

  /* Ask the value of the parameter to the user                 *
   * Only alow numbers and decimal point: "0123456789x, "       */
  sprintf(buf,"0x0, %dx%d",pWIDE,pHIGH);
  InputDialog("Introduce la posicin x,y tomando origen en la "
          " esquina superior izquierda, y el ancho y alto de la nueva imagen",
          buf, 64, "0123456789x, ", 1);
  
  /* Check for right values                                      */
  if (sscanf(buf,"%d x %d , %d x %d",&sx,&sy,&sw,&sh)!=4){
    Error("El formato de los parametros no es correcto");
    return;
  }

  newpic = XVGetSubImage(pic,picType,
             pWIDE,pHIGH,sx,sy,sw,sh);
  if (newpic) {
    StoreNewPic(newpic, picType, mono,
                   sw, sh, numcols);
  }  
}
/*********************************************************************************/
