/*********************************************************************************\
*     File:                  P R O Y _ A 1 . C P P                                *
*                                                                                 *
*     Standard   C++                                                              *
*                                                                                 *
\*********************************************************************************/
/*
 * proy_A1.cpp: main overview
 *
 *  Contains:
 *         void proy_A1();
 *         void doAlg_A1_24();
 *         void doAlg_A1_Grey();
 */

#include "inspect.h"
#include "..\Win32\YesNo.h"


/*********************************************************************************/
void Inspection::Ejemplo(void)
{
  Warning("Esta funcin est sin implementar");


  // NOTA: Esta funcin es llamada por la clase CInspectionDoc
  // AppWizard genera una funcin que se llama cuando se elige
  // en el men Inspeccin la opcin ejemplo
  // Desde la funcin que genera AppEstudio, se debe llamar
  // a esta funcin.

  // Hay dos alternativas:

  // A) Modificando en el fichero Win32/InspDoc.cpp la funcin
  //    que AppWizard genera para ese eventento de men:
  //    
  // afx_msg void CInspectionDoc::OnAlgProyA(void)
  // {
  //     Ejemplo(); //Llama a Inspection::Ejemplo
  //
  // }

  // B) Modificando en el fichero Win32/InspDoc.h la lnea
  //    en que aparece la funcin que AppWizard genera para
  //    ese eventento de men:
  //
  // afx_msg void OnAlgProyA() {Ejemplo();} //Llama a Inspection::Ejemplo
  //
  //    y a continuacin borrar la funcin CInspectionDoc::OnAlgProyA
  //    del fichero Win32/InspDoc.cpp



  printf("Funcin Inspection::AlgProyA\n"
         "============================\n");
  printf("La anchura de la imagen es: %d\n",pWIDE);
  printf("La altura de la imagen es: %d\n",pHIGH);
  printf("La imagen es en %s\n",(mono) ? "tonos de gris" : "color");
  
  // Pregunta al usuario un punto
  u_int i, j; // nmero de fila y columna
  do {
  printf("Introduce la fila y columna del pixel cuyo valor\n"
         "quieres conocer...\n");
  if (scanf("%u %u",&i,&j) != 2)
    printf("No se han leido los dos parmetros.\n");
  } while (i<1 || j<1 || i>pHIGH || j>pWIDE);

  // El primer elemento de la imagen es el punto (0,0) y no el (1,1)
  // por lo que se debe restar una unidad
  i--; j--;

  byte *thepic;         /* Copy of the formatted original image */
  byte *tmpPic;         /* Buffer where store transformed image */
  
  // Pongo el cursor en modo reloj de arena
  WaitCursor();

  //////////////////////////////////////////////////////////////////////////////////

  // Calcula la imagen en RGB COLOR
  if (start24bitAlg(&thepic, &tmpPic)) {
    printf("Fallo de la funcin start24bitAlg!!\n"
           "  (posiblemente al solicitar memoria).\n");
    return;
  }
  
  //En thepic tenemos la imagen original
  printf("El valor de la intensidad del punto (%i,%i) es R=%i, G=%i, B=%i\n"
         "(0 indica ausencia de esa componente,\n"
         "255 saturacin de la componte)\n",
         i+1 /*fila*/,
         j+1 /*columna*/,
         thepic[3*(i*pWIDE+j)+0] /*componente roja*/,
         thepic[3*(i*pWIDE+j)+1] /*componente verde*/,
         thepic[3*(i*pWIDE+j)+2] /*componente azul*/
         );

  // La imagen tmpPic est indefinida.
  // Como no queremos modificar la imagen, copiaremos la
  // imagen original en la nueva (si la imagen original
  // era en color, despus del algoritmo ser en tonos
  // de gris.
  memmove((char *) tmpPic/*dst*/,(char *) thepic/*src*/,
          (size_t) 3*pWIDE*pHIGH/*len*/);

  end24bitAlg(thepic, tmpPic);

  //////////////////////////////////////////////////////////////////////////////////
  // Calcula la imagen en TONOS DE GRIS
  if (startGreyAlg(&thepic, &tmpPic)) {
    printf("Fallo de la funcin startGreyAlg!!\n"
           "  (posiblemente al solicitar memoria).\n");
    return;
  }
  
  //En thepic tenemos la imagen original
  printf("El valor de la intensidad del punto (%i,%i) es %i\n"
         "(0 indica color negro, 255 blanco)\n",
         i+1,j+1,thepic[i*pWIDE+j]);
    

  // La imagen tmpPic est indefinida.
  // Como no queremos modificar la imagen, copiaremos la
  // imagen original en la nueva (si la imagen original
  // era en color, despus del algoritmo ser en tonos
  // de gris.
  memmove((char *) tmpPic/*dst*/,(char *) thepic/*src*/,
          (size_t) pWIDE*pHIGH /*len*/);

  endGreyAlg(thepic, tmpPic);

  if (!mono)
    printf("La funcin endGreyAlg ha convertido la imagen\n"
           "original de color a tonos de gris\n");

  //////////////////////////////////////////////////////////////////////////////////

  // Actualizo la imagen mostrada en la pantalla
  RedrawPic();

  // Pongo el cursor en modo reloj de arena
  ArrowCursor();

  //////////////////////////////////////////////////////////////////////////////////
  // Para ver la definicin de la funcin YesNo, mira el fichero "YesNo.h" del
  // directorio Win32
  int result = 
    YesNo("Otra forma alternativa de pregunar al usuario es por "
          "medio de cuadros de dilogo.\n"
          "Quieres guardar la imagen en fichero?");
  if (result == IDYES)
    Warning("Has pulsado \"S\"");

  if (result == IDNO)
    Warning("Has pulsado \"No\"");

  if (result == IDYES) {
    // Pregunta el nuevo fichero
    result = 
        YesNo("Quieres guardar la imagen en un fichero distinto?");
    result = 
      SavePic( (result==IDYES) ? SAVEPIC : REWRITEPIC);
    if (result != 0)
      Warning("Fallo al guardar la imagen!");
  }

  result = 
    YesNo("Quieres cargar una nueva imagen");
  if (result == IDYES) {
    // Carga una nueva imagen
    result = 
      OpenPic(LOADPIC);
    if (result != 0)
      Warning("Fallo al guardar la imagen!");
  }

  Warning("Fin de la funcin AlgProyA");
}
