/*=====================================================================*/
/*		    RUTINAS DE VISION POR ORDENADOR VISIO208.H	                 */
/* 			POR MIGUEL ANGEL MARTINEZ ESTEBAN	                             */
/*=====================================================================*/

#define IMPLEMENTATION_MIGUELAN  
#include "miguelan.h"


/*=====================================================================*/
/* 			RUTINAS DE AYUDA Y CONVERSION 		       */
/*=====================================================================*/


float valor_max_gradiente(unsigned char far *pt_imagen,int ncol, int nfil)

/* Calcula el valor maximo del modulo del gradiente de una imagen  */
/* y lo devuelve en la variable entera. Se usa para escalar luego  */
/* los sucesivos gradientes al valor mximo para la representacion.*/
{
 int x,y;
 int gx=0;                			/* Almacena el valor pasada a x */
 int gy=0;                			/* Almacena el valor pasada a y */
 double auxiliar;
 float max_gradxy;

 for (y=1;y<ncol-1;y++)
   for (x=1;x<nfil-1;x++)
     {
      gx=*(pt_imagen+(x+1)+y*nfil)-
	 *(pt_imagen+x+y*nfil);

/* Cambiamos el signo del gy para mantener el signo de los argumentos */
      gy=-(*(pt_imagen+x+(y+1)*nfil)-
	   *(pt_imagen+x+y*nfil));

      auxiliar=(double)gx*(double)gx+(double)gy*(double)gy;
      auxiliar=sqrt(auxiliar);		     /* Calculo el G(x,y)	    */
      if ( max_gradxy < (float)auxiliar )
	 max_gradxy=(float)auxiliar;
     }
 return max_gradxy;
}



void gradiente(unsigned char far *pt_imagen,
		unsigned char far *pt_gradientexy,
		unsigned char far *pt_gradientetita,
		float escala,
		int ncol,int nfil, int modo)

/* Realiza el gradiente de la imagen pasada como puntero pt_imagen      */
/* dejando el gradiente de la misma en la direccion pasada pt_gradiende */
/* con numero columnas ncol y numero de filas nfil de la imagen         */
/* La escala es la obtenida con el procedimiento valos_max_gradiente    */
/* Los angulos los deja escalados de (0..255) equivale a (0..360).	*/
{
 int gx=0;                			/* Almacena el valor pasada a x */
 int gy=0;                			/* Almacena el valor pasada a y */
 unsigned char gradxy=0;      			/* Valor del gradiente	  */
 int laplaciana=0;                              /* Valor de la segunda derivada para adelgazar contornos */
 double auxiliar;
 int x,y,angulo;
 float tita;

 for (x=0;x<nfil;x++)        			/* Elimina hacer el gradiente el los bordes */
 {
  *(pt_gradientexy+x)=0;       			/* linea de arriba       */
  *(pt_gradientexy+(nfil*(nfil-1))+x)=0;  	/* Linea de abajo        */
  *(pt_gradientexy+x*nfil)=0;    		/* Linea de la izquierda */
  *(pt_gradientexy+x*nfil-1)=0;  		/* Linea de la derecha   */
  *(pt_gradientetita+x)=0;       		/* linea de arriba       */
  *(pt_gradientetita+(nfil*(nfil-1))+x)=0;  	/* Linea de abajo        */
  *(pt_gradientetita+x*nfil)=0;    		/* Linea de la izquierda */
  *(pt_gradientetita+x*nfil-1)=0;  		/* Linea de la derecha   */
 }

 for (y=1;y<ncol-1;y++)
   for (x=1;x<nfil-1;x++)
     {
      gx=*(pt_imagen+(x+1)+y*nfil)-
	 *(pt_imagen+x+y*nfil);

/* Cambiamos el signo del gy para mantener el signo de los argumentos */
      gy=-(*(pt_imagen+x+(y+1)*nfil)-
	   *(pt_imagen+x+y*nfil));

      auxiliar=(double)gx*(double)gx+(double)gy*(double)gy;
      auxiliar=sqrt(auxiliar);		     /* Calculo el G(x,y)	    */
      gradxy=(unsigned char)(auxiliar*(double)escala);

						/* UMBRALIZO EL GRADIENTE */
      if (modo==1) 				/* MODO = 1 UMBRALIZA GRADIENTE */
	      if ( (gradxy>UMBRAL_GRADD) && (gradxy<UMBRAL_GRADU) )
	        gradxy=COLOR_GRAD_UMBRAL;
	      else
          gradxy=0;

      *(pt_gradientexy+x+y*nfil)=gradxy;      	/* Almaceno el valor de G(x,y) */


/* CALCULO DEL GRADIENTE DE ANGULOS SOLO SI GRADIENTE <> 0 */
/* Coloco el valor en 8 bits 256 valores escalados (0..255)=(0..360)*/
      if ( (gradxy!=0)  )
      {
       if ( (gx!=0) )        /* EL QUE RESULTE */
	 {
	  tita = 180.0 * atan( (float)gy/(float)gx ) / M_PI;
	  if (gx<0) tita=180.0+tita;
	  if ( (gx>0) & (gy<0) ) tita=360.0+tita;
	  angulo=ROUND(tita*255.0/360.0);
	  *(pt_gradientetita+x+y*nfil)=(unsigned char)angulo;
	 }
       if ( (gy!=0) & (gx==0) )        /* EL ANGULO ES 90 o 270 GRADOS */
	 if (gy>0) *(pt_gradientetita+x+y*nfil)=64;     /*  90 */
	    else *(pt_gradientetita+x+y*nfil)=191;      /* 270 */
      }
      else *(pt_gradientetita+x+y*nfil)=0;
     }
}


