/*=====================================================================*/
/*			RUTINAS DE VISION POR ORDENADOR		                             */
/* 			POR MIGUEL ANGEL MARTINEZ ESTEBAN	                             */
/*=====================================================================*/

/***********************************************************************/
/* Modificado por Joaqun Mur ( abril 1997) jmur@robot3.cps.unizar.es  */
/***********************************************************************/

#ifndef NULL
  #define NULL 0
#endif

#define UMBRALIZA 1                   
#define NO_UMBRALIZA 0
#define UMBRAL_GRADD 1                /* Umbral mnimo del gradiente para   */
                                      /* considerar posible contorno en el  */
                                      /* punto con umbralizado              */
#define UMBRAL_GRADU 256              /* Mximo valor del gradiente para    */
                                      /* considerar un posible contorno en  */
                                      /* el punto                           */ 
#define COLOR_GRAD_UMBRAL 31          /* Valor del gradiente en un punto    */
                                      /* entre UMBRAL_GRADD y UMBRAL_GRADU  */
#define MAX_SIGMA 65                  /* Valor Max_sigma = 4Sigma+1        */
#define MAX_LEVEL       7             /* MAX_LEVEL nunca ha de superar 7    */
                                      /* si se cambia el valor de MAX_LEVEL,*/
                                      /* hay que modificar BEDEC            */
#define MIN_LEVEL       2             /* Mayor escala a la cual se recalifica*/
                                      /* segmentos                          */
#define MIN_PERCENTAGE 0.2            /* Porcentaje (en tanto por 1) mnimo */
                                      /* para determinar un tipo de contorno*/
#define UMBRAL_DETECCION_MINIMO 10    /* valor mnimo del gradiente en      */
                                      /* supresion_puntos_32 y en deteccion_*/
                                      /* para estudiar si en el punto puede */
                                      /* haber un mximo local (contorno)   */
#define HOLGURA_ANG 16                /* mxima diferencia en grados 0..256 */
                                      /* que puede haber entre dos puntos   */
                                      /* contiguos o correspondientes en un */
                                      /* segmento.                          */

#define EPSILON 0.0005

/* Numero (0..255) asignado a cada tipo de punto contorno*/
#define GAP            4 
#define INDETERMINADO  8
#define ESCALERA      16
#define RAMPA         32
#define PULSO         64
#define ESCALON      128
  
#define SIGN(a)    (((a)>=0)?1:-1)
#define MAX(a,b)   (((a)<(b))?(b):(a))
#define MIN(a,b)   (((a)<(b))?(a):(b))
#define ROUND(a)   ((int)((a)+0.499))

  
#ifdef IMPLEMENTATION_MIGUELAN  
  #define EXTERN
  #ifdef _WINDOWS
    // Don't care far pointers. It's a 32-bit compiler!
    #define far
    #define farfree(a)  free(a)
  #endif
  #ifndef TRACE
    // if TRACE is undefined, use printf
    #ifdef DEBUG
      #define TRACE( ) printf( )
    #else
      #define TRACE( ) 
    #endif
  #endif
#else  //IMPLEMENTATION_MIGUELAN  
  #ifdef __cplusplus
     #define EXTERN extern "C"
  #else
     #define EXTERN extern      /* a reference to a GLOBAL function */
  #endif
#endif //VISION_IMPLEMENTATION


     /* CONSTANTES Y VARIABLES DEFINIDAS PARA LA TRANSFORMADA DE HOUGH */

 #define CTEHOUGHR 321  /* 321 */        /* SUSTITUIR SI QUEREMOS T. HOUGH */
 #define CTEHOUGHT 91  /* 91 */
 #ifndef M_PI
   #define M_PI 3.14159265359
 #endif 


 /* LAS BANDERAS GUARDAN LA ESTRUCTURA {'X','X','X','x','y',coor_x,coor_y}; */
struct tp_bandera {
	char c[5];
	int  x;
	int  y;
	};

#ifndef FALSE			/* in case these macros already exist */
    #define FALSE	0		/* values of boolean */
#endif

#ifndef TRUE
    #define TRUE	1
#endif

#ifndef byte
  #define byte unsigned char
#endif

#ifndef _WINDOWS
  #define __fastcall
  #define __inline
#endif

