// ChildFrm.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"
#include "..\\res\\resource.h"
#include "ChildFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define _CHILDFRM_CPP_
#include "Toolbars.h"

/////////////////////////////////////////////////////////////////////////////
// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CChildFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
    ON_MESSAGE(WM_COMMANDHELP, OnCommandHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame construction/destruction

CChildFrame::CChildFrame()
{
	// TODO: add member initialization code here
	
}

CChildFrame::~CChildFrame()
{
}


/////////////////////////////////////////////////////////////////////////////
// CChildFrame diagnostics

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG



BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

  // Don't allow maximize button
  // cs.style &= ~WS_MAXIMIZEBOX;

  // Don't allow resizing.
  cs.style &= ~WS_THICKFRAME;
	return CMDIChildWnd::PreCreateWindow(cs);
}


/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers

LRESULT CChildFrame::OnCommandHelp(WPARAM wParam, LPARAM lParam)
{
    if (lParam == 0) {
      if (m_nIDTracking > 0xe001) {
        // frames own menu (system menu)
        lParam = HID_BASE_COMMAND + m_nIDTracking;
      }
      else {
        CView* pView = GetActiveView();
        if (pView) {
          // delegate the Help command to the view
          return pView->SendMessage(WM_COMMANDHELP, wParam, 0L);
        }
        else {
          lParam = HID_BASE_RESOURCE + IDR_MAINFRAME;
        }
      }
    }
    if (lParam != 0) {
      AfxGetApp()->WinHelp(lParam);
      return TRUE;
    }
    return FALSE;
}

void CChildFrame::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	// The following technique works only with CScrollView derived views
	// with or without splitter panes
	CScrollView* pView = (CScrollView *) GetActiveView();

	// we might not have a view attached yet
	if (pView)
	{
		ASSERT(pView->IsKindOf(RUNTIME_CLASS(CScrollView)));
		DWORD dwExStyle = pView->GetExStyle();
			
		CRect rect (CPoint(0, 0), pView->GetTotalSize());
		CalcWindowRect (rect);

		CSize size;
		size.cx = rect.Width();
		size.cy = rect.Height();

		if (dwExStyle & WS_EX_CLIENTEDGE)
		{
			size.cx += 4;
			size.cy += 4;
		}

		if (GetExStyle() & WS_EX_CLIENTEDGE)
		{
			size.cx += 4;
			size.cy += 4;
		}

		// Use the following code if you have a splitter window:

		// The width and height of the splitter is fixed to 4 pixels 
		// (judging from the constructor in winsplit.cpp)
		// This may change in the future, but m_cxSplitter and m_cySplitter
		// aren't public members so there's no programatic way to find out.

		//lpMMI->ptMaxTrackSize.x = size.cx + GetSystemMetrics(SM_CXVSCROLL) + 4;
		//lpMMI->ptMaxTrackSize.y = size.cy + GetSystemMetrics(SM_CYHSCROLL) + 4;

		// Otherwise, remove the comments and use this code:
		lpMMI->ptMaxTrackSize.x = size.cx;
		lpMMI->ptMaxTrackSize.y = size.cy;
	}	
	//CMDIChildWnd::OnGetMinMaxInfo(lpMMI);
}

/////////////////////////////////////////////////////////////////////////////
// CImgFrame

IMPLEMENT_DYNCREATE(CImgFrame, CMDIChildWnd)

CMenu CImgFrame::m_menu;

BOOL CImgFrame::Create(  LPCTSTR lpszCDibViewClass, LPCTSTR lpszWindowName, 
                         DWORD dwStyle/* = 0 */, const RECT& rect/* = rectDefault */,
                         CMDIFrameWnd* pParentWnd /* = NULL */,
                         CCreateContext* pContext /* = NULL */) 

{
	// TODO: Add your specialized code here and/or call the base class

  // Setup the shared menu
	if (m_menu.m_hMenu == NULL)
    	if (!m_menu.LoadMenu(IDR_IMGBASICTYPE))
		    return FALSE;

  // when the list output frame window is active, use this menu
	m_hMenuShared = m_menu.m_hMenu;

	// Register a custom WndClass and create a window.
	// This must be done because CImgBasicDoc has a custom icon.

  if (lpszCDibViewClass == NULL) 
    lpszCDibViewClass =
		  AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW,
			LoadCursor(NULL, IDC_ARROW),
			(HBRUSH) (COLOR_WINDOW+1),
			LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_IMGBASICTYPE)));

	// create the CMDIChildWnd
	return CChildFrame::Create(lpszCDibViewClass, lpszWindowName,
                              dwStyle, rect, pParentWnd, pContext);
  
}

/////////////////////////////////////////////////////////////////////////////
// CDibFrame

IMPLEMENT_DYNCREATE(CDibFrame, CMDIChildWnd)

CMenu CDibFrame::m_menu;

BOOL CDibFrame::Create(  LPCTSTR lpszCDibViewClass, LPCTSTR lpszWindowName, 
                         DWORD dwStyle/* = 0 */, const RECT& rect/* = rectDefault */,
                         CMDIFrameWnd* pParentWnd /* = NULL */, 
                         CCreateContext* pContext /* = NULL */) 

{
	// TODO: Add your specialized code here and/or call the base class

  // Setup the shared menu
	if (m_menu.m_hMenu == NULL)
    	if (!m_menu.LoadMenu(IDR_DIBTYPE))
		    return FALSE;
  // when the list output frame window is active, use this menu
	m_hMenuShared = m_menu.m_hMenu;

	// Register a custom WndClass and create a window.
	// This must be done because CImgBasicDoc has a custom icon.

  if (lpszCDibViewClass == NULL) 
	  lpszCDibViewClass =
		  AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW,
			LoadCursor(NULL, IDC_ARROW),
			(HBRUSH) (COLOR_WINDOW+1),
			LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_DIBTYPE)));

	// create the CMDIChildWnd
  return CChildFrame::Create(lpszCDibViewClass, lpszWindowName,
                              dwStyle, rect, pParentWnd, pContext);
}


/////////////////////////////////////////////////////////////////////////////
// CInspectionFrame

IMPLEMENT_DYNCREATE(CInspectionFrame, CMDIChildWnd)

CMenu CInspectionFrame::m_menu;

BOOL CInspectionFrame::Create(  LPCTSTR lpszCDibViewClass, LPCTSTR lpszWindowName, 
                         DWORD dwStyle/* = 0 */, const RECT& rect/* = rectDefault */,
                         CMDIFrameWnd* pParentWnd /* = NULL */,
                         CCreateContext* pContext /* = NULL */) 

{
	// TODO: Add your specialized code here and/or call the base class

  // Setup the shared menu
	if (m_menu.m_hMenu == NULL)
    	if (!m_menu.LoadMenu(IDR_INSPECTIONTYPE))
		    return FALSE;

  // when the list output frame window is active, use this menu
	m_hMenuShared = m_menu.m_hMenu;

	// Register a custom WndClass and create a window.
	// This must be done because CImgBasicDoc has a custom icon.

  if (lpszCDibViewClass == NULL) 
	  lpszCDibViewClass =
		  AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW,
			LoadCursor(NULL, IDC_ARROW),
			(HBRUSH) (COLOR_WINDOW+1),
			LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_INSPECTIONTYPE)));

	// create the CMDIChildWnd
	return CChildFrame::Create(lpszCDibViewClass, lpszWindowName,
                              dwStyle, rect, pParentWnd, pContext);

}

