#include <limits.h>
#include "dibdoc.h"
#include "..\res\resource.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// C L I P    B O A R D   S U P O R T   F O R  C D i b D o c


void CDibDoc::OnEditCopy() 
{
	// TODO: Add your command handler code here
  // Clean clipboard of contents, and copy the DIB.
	if (OpenClipboard(NULL))
	{
		BeginWaitCursor();
		EmptyClipboard();
    
    /* Set contents on the clipboard */
    HANDLE hcopy =  CopyHandle((HANDLE) GetHDIB());
    if (hcopy==NULL) {
      Error("No he podido copiar el handle del bitmap (HDIB)");
      CloseClipboard();
		  EndWaitCursor();
      return;
    }

		SetClipboardData (CF_DIB, hcopy );

    CloseClipboard();
		EndWaitCursor();
	}
  else Error("OnEditCopy: No he podido abrir el portapales");
}

void CDibDoc::OnEditCut() 
{
	// TODO: Add your command handler code here
  OnEditCopy();
  if (IOfile::pic != NULL) {
    // Free IOfile's pic and save real image in case undo    
    StoreNewPic(NULL,PIC8,FALSE);
    // Update all views
    RedrawPic();
  }
}

void CDibDoc::OnEditPaste() 
{
	// TODO: Add your command handler code here
    if ( ::IsClipboardFormatAvailable(CF_DIB) )
        OnEditPasteDib();
    else if ( ::IsClipboardFormatAvailable(CF_BITMAP) )
        OnEditPasteDdb();
    else Error ("Formato del portapapeles no soportado");
    // Repaint the bitmap shown in the window
}

void CDibDoc::OnEditPasteDdb() 
{
	// TODO: Add your command handler code here
    if (OpenClipboard (NULL))
     {
        BeginWaitCursor();
        // Free IOfile's pic and save real image in case undo    
        StoreNewPic(NULL,PIC8,FALSE);
        HBITMAP hbm = NULL;
        if (hbm = (HBITMAP) GetClipboardData(CF_BITMAP)) 
        {
            // It is not necessary delete explicitly old data because
            // member functions release old data when a new one is
            // attached to the object.

            /*
             * If there is a CF_PALETTE object in the
             * clipboard, this is the palette to assume
             * the bitmap is realized against.
             */
            
            HBITMAP hBITMAP = (HBITMAP) CopyHandle ((HANDLE) hbm );
            if (hBITMAP == NULL) {
              Error("CDibDoc::OnEditPasteDdb\nBitmap en portapales vacio");
              CloseClipboard ();
              EndWaitCursor();
              return;
            }
            SetHBITMAP( hBITMAP );
            HPALETTE hpal = (HPALETTE) GetClipboardData(CF_PALETTE);
            if (hpal != NULL)
                SetHPALETTE( CopyPalette(hpal) );
            SetIMAGE( hbm );
        }
        else 
            Error("No hay bitmap disponible en el portapeles!");
        CloseClipboard ();
        EndWaitCursor();
    }	
}


void CDibDoc::OnEditPasteDib() 
{
		// TODO: Add your command handler code here
    if (OpenClipboard (NULL)) {
        BeginWaitCursor();
        // Free IOfile's pic and save real image in case undo    
        StoreNewPic(NULL,PIC8,FALSE);
        HANDLE h;
        if (h = GetClipboardData (CF_DIB)) 
          SetIMAGE((HDIB) h);
        else 
          Error("No se puede pegar porque no hay HDIB disponible en el portapeles!");

        CloseClipboard();
        EndWaitCursor();
    }
}



//////////////////////////////////////////////////////////////////////////
