// dibview.cpp : implementation of the CDibView class
//

#include <math.h>
#include "stdafx.h"
#include "VisioApp.h"
#include "dibdoc.h"
#include "dibview.h"
#include "dibapi.h"
#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
/*
BOOL CDibView::m_bDirectDraw=FALSE; // True for use m_hBITMAP
                                    // False to display m_DIB directly
*/
/////////////////////////////////////////////////////////////////////////////
// CDibView

IMPLEMENT_DYNCREATE(CDibView, CScrollView)

BEGIN_MESSAGE_MAP(CDibView, CScrollView)
	//{{AFX_MSG_MAP(CDibView)
	ON_MESSAGE(WM_DOREALIZE, OnDoRealize)
	ON_MESSAGE(WM_COMMANDHELP, OnCommandHelp)
	ON_MESSAGE(WM_HELPHITTEST, OnHelpHitTest)
	ON_COMMAND(ID_IMAGE_INFORMATION, OnImageInformation)
	ON_COMMAND(ID_ZOOM25, OnZoom25)
	ON_COMMAND(ID_ZOOM50, OnZoom50)
	ON_COMMAND(ID_ZOOM100, OnZoom100)
	ON_COMMAND(ID_ZOOM200, OnZoom200)
	ON_COMMAND(ID_ZOOM400, OnZoom400)
	ON_COMMAND(ID_ZOOM_SIZETOFIT, OnZoomSizetoFit)
	//}}AFX_MSG_MAP

	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDibView construction/destruction
/*
CDibView::CDibView() : m_ScrollSize(0,0),m_Scale(100,100),m_autoadjust(FALSE)
{} */


CDibView::~CDibView()
{
    FreeViewData();
}


/////////////////////////////////////////////////////////////////////////////
// CDibView drawing

void CDibView::OnDraw( CDC* pDC )
{
#ifdef _DEBUG
  FlashWindow( TRUE );
#endif //  _DEBUG
  HBITMAP hBITMAP ;
  // If there is no bitmap compatible, make one from image
  if (( GetDocument()->m_redraw || pDC->IsPrinting() ) 
       && GetDocument()->GetWidth()>0 && GetDocument()->GetHeight()>0 ) {  
    TRACE("\nCDibDoc::OnDrawDdb. Reload of bitmap\n");
    CSize ScaledSize =  GetDocument()->GetSize();
    
    if ( m_autoadjust && !pDC->IsPrinting()) {
        // Autoadjust bitmap to windows size
        SetScaleToFitSize( GetDocument()->GetSize() );	
        SetScrollSizes( MM_TEXT, ScaledSize);
    } else {
        //ZOOM FACTOR
        ScaledSize.cx = ScaledSize.cx * m_Scale.cx / 100;
        ScaledSize.cy = ScaledSize.cy * m_Scale.cy / 100;
        SetScrollSizes( MM_TEXT, ScaledSize);
        ResizeParentToFit( );   // Default bShrinkOnly argument
	    }    
    
    if ((hBITMAP = GetHBITMAP(pDC))==NULL) { 
        SetHPALETTE(NULL);
        SetHBITMAP(NULL);
        HDIB hDIB = GetDocument()->GetHDIB();
        SetHBITMAP(hBITMAP = GetDocument()->BITMAPfromHDIB(hDIB,pDC));
        GlobalFree(hDIB);
        Error("CDibView::OndrawDdb 4\nLa copia del bitmap en memoria est vacia");
        //return;
    } else
      GetDocument()->m_redraw=FALSE;

  // else redraw or printring
  } else hBITMAP = GetHBITMAP(pDC);
    

  TRACE("\nCDibDoc::OnDrawDdb\n");
  // Warning if hbitmap is empty and the image exist
  if ( GetDocument()->GetWidth()>0 && GetDocument()->GetHeight()>0 
       && (hBITMAP == NULL ) )
      Warning("CDibView::OnDraw 1\nEl bitmap en memoria est vaco");
  
  // If we were here then hBITMAP != NULL 

  // Size of the image
  CSize SizeSrc( GetDocument()->GetSize() );
  // Size of destination
  CSize SizeDst( GetSize() );
	
  // Before copying the BITMAP to device, get a safe memory context device
  CDC memdc;
  memdc.CreateCompatibleDC(pDC);
  if ( memdc.GetSafeHdc() == NULL ) {
    Error("CDibView::Ondraw 4\nNo puedo crear un dispositivo de memoria compatible");
    return; 
  }
  
  // We have a memory device contex compatible.

  HPALETTE hOldPal = NULL;
  // Select and realize the palette.
  // OnDoRealize updates the color table for you
  if (GetDocument()->UsePalette && GetHPALETTE()!=NULL)
  {
      // Do the memDC palette foreground regardless the view is seledte.
      SelectPalette(memdc.m_hDC,GetHPALETTE(), FALSE ); 
      memdc.RealizePalette();
      // If the view is selected, OnDoRealize makes the palette foreground/background
      hOldPal = SelectPalette(pDC->m_hDC,GetHPALETTE(), TRUE );
      pDC->RealizePalette();
  }
#ifdef _DEBUG
  // Warning if there is no palette and the bitmap requires one.
  if (  GetDocument()->pic && GetDocument()->m_hBITMAP
        && GetDocument()->GetWidth()>0 && GetDocument()->GetHeight()>0 &&
        GetDocument()->UsePalette && GetHPALETTE() == NULL && NumColors() )
    { Warning("CDibView::OnDraw 2\nLa paleta est incompleta");}
  // If there is no bitmap do nothing
  if (hBITMAP==NULL && GetDocument()->GetWidth()>0 
      && GetDocument()->GetHeight()>0 ) {  
      Error("CDibView::Ondraw 3\nLa copia del bitmap en memoria est vacia");        
  }
#endif  //_DEBUG

  
  pDC->SetStretchBltMode(COLORONCOLOR);
  SelectObject(memdc.m_hDC, hBITMAP);

  

  // Do autoscale keeping the proportions to fill the page 
  if (pDC->IsPrinting())   // printer DC
	{
		// get size of printer page (in pixels)
		int cxPage = pDC->GetDeviceCaps(HORZRES);
		int cyPage = pDC->GetDeviceCaps(VERTRES);
		// get printer pixels per inch
		int cxInch = pDC->GetDeviceCaps(LOGPIXELSX);
		int cyInch = pDC->GetDeviceCaps(LOGPIXELSY);

		//
		// Best Fit case -- create a rectangle which preserves
		// the DIB's aspect ratio, and fills the page horizontally.
		//
		// The formula in the "->bottom" field below calculates the Y
		// position of the printed bitmap, based on the size of the
		// bitmap, the width of the page, and the relative size of
		// a printed pixel (cyInch / cxInch).
		//
    SizeDst.cy = (int)(((double)SizeSrc.cy * cxPage * cyInch)
		              / ((double)SizeSrc.cx * cxInch));
		SizeDst.cx = cxPage;
	}
	
  // Use BitBlt if scale is 1:1
  if ((SizeDst.cx == SizeSrc.cx) && (SizeDst.cy == SizeSrc.cy))
  {    // Direct bit copy, without scaling
       BOOL bSuccess;
       bSuccess = pDC->BitBlt( 0, 0, SizeSrc.cx, SizeSrc.cy, &memdc,
                              0, 0, SRCCOPY);               
       if (!bSuccess) Error ("Fallo en OnDraw -> BitBlt\n"
                             "Transfiriendo el bitmap al contexto");
  }
  else {    // Copy scaled bitmap to DC 
       BOOL bSuccess;
       bSuccess = pDC->StretchBlt( 0, 0, SizeDst.cx , SizeDst.cy,
                         &memdc, 0, 0, SizeSrc.cx, SizeSrc.cy, SRCCOPY);
       if (!bSuccess) Error ("Fallo en OnDraw -> StretchBlt\n"
                             "Transfiriendo el bitmap al contexto");
  }

  if ( GetDocument()->UsePalette && hOldPal != NULL) {
        SelectPalette(pDC->m_hDC, hOldPal, TRUE );
        //pDC->RealizePalette();
  }
  memdc.DeleteDC();

  if (GetDocument()->SaveMemory()) SetHBITMAP(NULL);

#ifdef _DEBUG
  FlashWindow( FALSE );
#endif //  _DEBUG
}

/////////////////////////////////////////////////////////////////////////////
// CDibView printing

BOOL CDibView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CDibView commands


LRESULT CDibView::OnDoRealize(WPARAM wParam, LPARAM)
{
	ASSERT(wParam != NULL);
	if (GetDocument()->pic == NULL)
		return -1L;  // must be a new document

	HPALETTE hPal = GetHPALETTE();
	if (hPal != NULL)
	{
		CMainFrame* pAppFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
		ASSERT_KINDOF(CMainFrame, pAppFrame);

		CClientDC appDC(pAppFrame);
		// All views but one should be a background palette.
		// wParam contains a handle to the active view, so the SelectPalette
		// bForceBackground flag is FALSE only if wParam == m_hWnd (this view)
		HPALETTE oldPalette = SelectPalette(appDC.m_hDC, hPal, 
       (((HWND)wParam) != m_hWnd)/* || (!IsChild(m_hWnd)) */);

		if (oldPalette != NULL)
		{
			UINT nColorsChanged = RealizePalette(appDC.m_hDC);
            // There is a increasing limit to avoid beeing realizing palettes
            // in a vicious circle.
			SelectPalette(appDC.m_hDC,oldPalette, TRUE);
      if (nColorsChanged > 0)  GetDocument()->UpdateAllViews(NULL);
		}
		else
		{
      Error("SelectPalette fall en CDibView::OnPaletteChanged\n");
      return -1L;
		}
	}

	return 0L;
}

/****************************************************************************
 *                                                                          *
 *  FUNCTION   : OnInitialUpdate()                                          *
 *                                                                      z    *
 *  PURPOSE    : Sets view internal data from its document since this func- *
 *               tion is called when the view is attached to its document.  *
 ****************************************************************************/
// OnInitialUpdate is called just after asociating view and document, so
// its used to adjust the view with information contained in the document.
void CDibView::OnInitialUpdate()
{
	ASSERT(GetDocument() != NULL);
  
  //GetTopLevelParent()->GetMenu()->CheckMenuItem(ID_ZOOM100,MF_CHECKED);
  m_ScrollSize =  GetDocument()->GetSize();
  GetParentFrame()->CalcWindowRect(CRect(CPoint(0,0),m_ScrollSize));
  GetParentFrame()->SetWindowPos(NULL,0,0,m_ScrollSize.cx,
    m_ScrollSize.cy, SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOZORDER);
  
	SetScrollSizes(MM_TEXT, GetSize());
  if (m_autoadjust) // Autoadjust bitmap to windows size
      SetScaleToFitSize( GetDocument()->GetSize() );	
    else
      ResizeParentToFit( );   // Default bShrinkOnly argument
	CScrollView::OnInitialUpdate();

  // Call twice ResizeParentToFit
  // First time, enlarge wiew and eliminate scroll bars.
  // Second time, reduce size of view to minimum size without
  // scroll bars
  ResizeParentToFit(FALSE);
  GetDocument()->m_redraw=TRUE;
  ResizeParentToFit(TRUE);
  OnDoRealize((WPARAM)m_hWnd,0); //realize the new Palette
}

// OnActivateView is called for activate the palette.
void CDibView::OnActivateView(BOOL bActivate, CView* pActivateView,
					CView* pDeactiveView)
{
	CScrollView::OnActivateView(bActivate, pActivateView, pDeactiveView);
	if (bActivate || GetDocument()->m_redraw)
	{
		ASSERT(pActivateView == this);
		OnDoRealize((WPARAM)m_hWnd, 0);   // same as SendMessage(WM_DOREALIZE);
	}
}


/****************************************************************************
 *                                                                          *
 *  FUNCTION   : FreeViewData(void)                                         *
 *                                                                          *
 *  PURPOSE    : Frees all currently DibView data.                          *
 *                                                                          *
 ****************************************************************************/
void CDibView::FreeViewData()
{
    //m_BITMAPSuitableForPrinting = FALSE;
    //m_ScrollSize = GetDocument()->GetSize();
}


/****************************************************************************
 *                                                                          *
 *  FUNCTION   : SetScrollSizes()                                           *
 *                                                                          *
 *  PURPOSE    : Fixes the actual scrolling model of the window.            *
 *                                                                          *
 ****************************************************************************/
 void CDibView::SetScrollSizes( int nMapMode, SIZE sizeTotal,
                                        const SIZE& sizePage, const SIZE& sizeLine)
{
    if ( (sizeTotal.cx==0) || (sizeTotal.cy==0) ) {
        SIZE SafeSize(CSize(1,1));    // dummy value to make CScrollView happy
        CScrollView::SetScrollSizes( nMapMode, SafeSize, sizePage, sizeLine );
    } else {
        m_ScrollSize.cx = GetDocument()->GetWidth()*m_Scale.cx/100 ;
        m_ScrollSize.cy = GetDocument()->GetHeight()*m_Scale.cy/100;
        CScrollView::SetScrollSizes( nMapMode, sizeTotal, sizePage, sizeLine );
    }
}

void CDibView::OnImageInformation() 
{
	// TODO: Add your command handler code here
    CSize Tamano=GetSize();
    char cadena[512];
    int i;
    i=sprintf(cadena,"Imagen: %s\nTamao de la imagen: (%u,%u)\nNmero de colores: %u\n"
      "Bitmap en memoria: %s\nPaleta en memoria: %s\n",
                  GetDocument()->GetPathName(),
                  Tamano.cx, Tamano.cy,
                  GetDocument()->NumColors(),
                  (GetDocument()->m_hBITMAP==NULL) ? "No" : "S",
                  (GetDocument()->m_hPALETTE==NULL) ? "No" : "S");
    i+=sprintf(cadena+i,"Formato interno: %s\n",
      GetDocument()->picType ? "RGB (3 byte/pixel)" : GetDocument()->mono ?
      (GetDocument()->numcols==2) ?"monocromo" : "mapa de grises" :
      "mapa de colores");
    MessageBox( cadena, "Informacin sobre la imagen", MB_ICONINFORMATION | MB_OK);
    GetDocument()->drawStrings();
    if (GetDocument()->SaveMemory()) SetHBITMAP(NULL);
}

VOID CDibView::Warning (LPCTSTR strMsg )
{
    char cadena[60];
    sprintf(cadena,"Imagen: %s, clase CDibView",GetDocument()->GetTitle()); 
    MessageBox( strMsg, cadena, MB_ICONEXCLAMATION | MB_OK);
}

VOID CDibView::Error(LPCTSTR strMsg)
{
    char cadena[60];
    sprintf(cadena,"Imagen: %s, clase CDibView",GetDocument()->GetTitle()); 
    MessageBox( strMsg, cadena, MB_ICONSTOP | MB_OK);
}

VOID CDibView::FatalError(LPCTSTR strMsg)
{
    char cadena[60];
    sprintf(cadena,"Error Fatal!!! Imagen: %s, clase CDibView",GetDocument()->GetTitle()); 
    MessageBox( strMsg, cadena , MB_ICONSTOP | MB_OK);
    exit(-1);
}

void CDibView::OnZoom(u_int factor) 
{
	// TODO: Add your command handler code here
    m_autoadjust = FALSE;
    char string[128];
    sprintf(string,"%s  Zoom %i%",_T(GetDocument()->GetPathName()),factor);
	  GetDocument()->SetTitle((CString)string);
    m_Scale.cx=m_Scale.cy= (long) sqrt((double)factor*100.0);
    Invalidate();           // Ask for a rewrite
    m_ScrollSize.cx = GetDocument()->GetWidth() * m_Scale.cx / 100;
    m_ScrollSize.cy = GetDocument()->GetHeight() * m_Scale.cy /100;
    SetScrollSizes(MM_TEXT, m_ScrollSize ); 
 	  // Don't allow resizing.
    ModifyStyle( WS_THICKFRAME, 0); 
    ResizeParentToFit( );   // Resize window
}

void CDibView::OnZoom100() 
{
	// TODO: Add your command handler code here
	  m_autoadjust = FALSE;
    GetDocument()->SetTitle(GetDocument()->GetPathName());
    m_ScrollSize.cx = GetDocument()->GetWidth();
    m_ScrollSize.cy = GetDocument()->GetHeight();
    m_Scale.cx=100;m_Scale.cy=100;
    Invalidate();           // Ask for a rewrite
    SetScrollSizes(MM_TEXT, m_ScrollSize ); 
    ResizeParentToFit( );   // Resize window
	  // Don't allow resizing.
    GetParentFrame()->ModifyStyle( WS_THICKFRAME, 0); 
}

void CDibView::OnZoomSizetoFit() 
{
	// TODO: Add your command handler code here
    m_autoadjust = TRUE;
    CString string(GetDocument()->GetPathName());
    string += " Autoajuste";
	  GetDocument()->SetTitle(string);
    m_ScrollSize.cx = GetDocument()->GetWidth();
    m_ScrollSize.cy = GetDocument()->GetHeight();
    m_Scale.cx=100; m_Scale.cy=100;
    if ( (m_ScrollSize.cx==0) || (m_ScrollSize.cy==0) ) 
        m_ScrollSize = CSize(1,1);    // dummy value to make CScrollView happy        
    SetScrollSizes(MM_TEXT, m_ScrollSize );
    SetScaleToFitSize( m_ScrollSize );
 	  // Allow resizing.
    GetParentFrame()->ModifyStyle( 0, WS_THICKFRAME ); 
}

/****************************************************************************
 *                                                                          *
 *  FUNCTION   : InitDibData(Is_the_document_to_be_saved?)                  *
 *                                                                          *
 *  PURPOSE    : Updates the views and the document when a member variable  *
 *               has changed                                                *
 ****************************************************************************/
void CDibView::InitDibData( BOOL bSetModifiedFlag, CDC* pDC)
{
    // if bSetModifiedFlag is TRUE, the program will ask for save
    // before closing the image.
    CSize m_ScrollSize =  GetDocument()->GetSize();
    m_ScrollSize.cx = m_ScrollSize.cx * m_Scale.cx / 100;
    m_ScrollSize.cy = m_ScrollSize.cy * m_Scale.cy / 100;
    if ( (m_ScrollSize.cx==0) || (m_ScrollSize.cy==0) ) 
        m_ScrollSize = CSize(1,1);    // dummy value to make CScrollView happy        
    SetScrollSizes( MM_TEXT, m_ScrollSize);
    if (m_autoadjust) // Autoadjust bitmap to windows size
      SetScaleToFitSize( m_ScrollSize );	
    else
      ResizeParentToFit( );   // Resize window
    OnDoRealize((WPARAM)m_hWnd,0); //realize the new Palette
    GetDocument()->InitDibData(bSetModifiedFlag,pDC);
}

afx_msg void CDibView::OnInitMenu( CMenu* pMenu )
{
  // This fucntion is called before displaying a menu
  pMenu->CheckMenuItem(ID_SAVE_MEMORY,
          GetDocument()->SaveMemory()? MF_CHECKED : MF_UNCHECKED);
  pMenu->EnableMenuItem(ID_EDIT_CUT,
          GetDocument()->pic==NULL ? MF_GRAYED: MF_ENABLED);
  pMenu->EnableMenuItem(ID_EDIT_COPY,
          GetDocument()->pic==NULL ? MF_GRAYED: MF_ENABLED);
  pMenu->EnableMenuItem(ID_EDIT_UNDO,
          GetDocument()->IsUndoAvailable() ? MF_GRAYED: MF_ENABLED);
  pMenu->EnableMenuItem(ID_EDIT_PASTE,
          ::IsClipboardFormatAvailable(CF_DIB) ? MF_GRAYED: MF_ENABLED);
  pMenu->EnableMenuItem(ID_EDIT_PASTE,
          (::IsClipboardFormatAvailable(CF_DIB) ||
           ::IsClipboardFormatAvailable(CF_BITMAP) ) ? MF_GRAYED: MF_ENABLED);                  

  CWnd::OnInitMenu(pMenu);
}

/****************************************************************************/
LRESULT CDibView::OnCommandHelp(WPARAM wParam, LPARAM lParam)
{
    if (lParam == 0) {
        lParam = HID_BASE_RESOURCE + IDR_DIBTYPE;
    }
    // context already determined above--we dont modify it
    AfxGetApp()->WinHelp(lParam);
    return TRUE;
}

/****************************************************************************/
LRESULT CDibView::OnHelpHitTest(WPARAM wParam, LPARAM lParam)
{
    return HID_BASE_RESOURCE + IDR_DIBTYPE;
}
