// Format.cpp : Contains
//                           CDibDoc::ChangeImageFormat
//                           implementation
//

#include "stdafx.h"
#include "..\\res\\resource.h"
#include "dibdoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormaDlg dialog

class CFormaDlg : public CDialog
{
public:
    static int   threshold;
    static BOOL  pasoApaso;

    /* Owner document */
    CDibDoc *pDoc;
    /* Pointer to where new black & white image is wrote */
    byte *pBWpic;

// Construction
public:
	CFormaDlg(CWnd* pParent = NULL);   // copy constructor
  void ShowImageInBW (int threshold);
// Dialog Data
protected:
	//{{AFX_DATA(CFormaDlg)
	enum  { IDD = IDD_BLACKWHITE };
  BOOL  m_PasoApaso;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFormaDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CFormaDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnHelp();
	afx_msg void OnSeguimiento();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/*********************************************************************************/

/////////////////////////////////////////////////////////////////////////////
// CFormaDlg static inizalitation

int     CFormaDlg::threshold=127;
BOOL    CFormaDlg::pasoApaso=FALSE;

/////////////////////////////////////////////////////////////////////////////
// CFormaDlg dialog

CFormaDlg::CFormaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFormaDlg::IDD, pParent),
  m_PasoApaso(pasoApaso),pDoc(NULL),pBWpic(NULL)
{
	//{{AFX_DATA_INIT(CFormaDlg)
		// NOTE: the ClassWizard will add member initialization here
 	
	//}}AFX_DATA_INIT
}

BOOL CFormaDlg::OnInitDialog() 
{
    CString Str;
    CSliderCtrl* pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_THERESHOLD);
    pSlider->SetRange(0, 255);
    pSlider->SetPos(threshold);
    Str.Format("Umbral del color blanco: %d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_THRESHOLD, Str);

    return CDialog::OnInitDialog();
}

void CFormaDlg::DoDataExchange(CDataExchange* pDX)
{ 
  /* if (pDX->m_bSaveAndValidate)==FALSE
   * Uptate local variables with persistent ones
   * and update dialog controls */
  if (!(pDX->m_bSaveAndValidate)) {
    m_PasoApaso=pasoApaso;

     ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD))
             ->SetPos(threshold);
    }

  CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CFormaDlg)
    DDX_Check(pDX, IDC_PASO_A_PASO, m_PasoApaso);
	//}}AFX_DATA_MAP
    
  /* if (pDX->m_bSaveAndValidate)==TRUE
   * Uptate static variables with dialog values
   * For example, when OK button is pressed
   */
  if (pDX->m_bSaveAndValidate) {
    pasoApaso=m_PasoApaso;
    threshold = ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD))
             ->GetPos();
  }
}

BEGIN_MESSAGE_MAP(CFormaDlg, CDialog)
	//{{AFX_MSG_MAP(CFormaDlg)
	ON_BN_CLICKED(IDC_HELP_CANY, OnHelp)
	ON_BN_CLICKED(IDC_PASO_A_PASO,OnSeguimiento)
  ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormaDlg message handlers


void CFormaDlg::OnHelp() 
{
  MessageBox("La ayuda no est todava a punto","Ayuda");
}

void CFormaDlg::OnSeguimiento() 
{
  /* Update m_PasoApaso every time checkbox
   * is pressed */
  pasoApaso=m_PasoApaso=
    IsDlgButtonChecked(IDC_PASO_A_PASO);
}

void CFormaDlg::OnHScroll(UINT nSBCode, UINT nPos,
                             CScrollBar* pScrollBar) 
{
  static BOOL Redrawing = FALSE ;
  CSliderCtrl* pSlide = (CSliderCtrl*) pScrollBar;    
  CString strText;
  strText.Format("Umbral del color blanco: %d", pSlide->GetPos());
  SetDlgItemText(IDC_STATIC_THRESHOLD, strText);
             
  if ( !Redrawing && m_PasoApaso ) { /* compute new image if it isn't yet */
    Redrawing = TRUE;
    int level = ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD))->GetPos();
    /* Only compute new image if slider has changed since last time */
    if (level != threshold ) {
      threshold = level;
      ShowImageInBW ( threshold ) ;
    }
    /* The new image is computed and shown. Therefore, next
     * time the slider changes, a new image will be calculated
     */
    Redrawing = FALSE;
  }
}

/*********************************************************************************/
/* Show temporal image                                                           */
void CFormaDlg::ShowImageInBW(int threshold)
{
  byte *FormerPic;
  int formerPicType, formerMono,i;
  u_int formerNumcols;
  byte formerRmap[2], formerGmap[2], formerBmap[2];

  /* return if there is nothing to do! */
  if (!pDoc->pic || !pDoc->pWIDE ||
      !pDoc->pHIGH || pDoc->numcols == 2 ) return;
  
  // Back-up former values
  FormerPic=pDoc->pic;
  formerPicType = pDoc->picType;
  formerMono = pDoc->mono;
  formerNumcols = pDoc->numcols;
  
  // Back-up original colormap
  xvbcopy((char *)pDoc->rMap, (char *)formerRmap, 2);
  xvbcopy((char *)pDoc->gMap, (char *)formerGmap, 2);
  xvbcopy((char *)pDoc->bMap, (char *)formerBmap, 2);
 
  // Convert former image to BW
  
    /* CONVERSION */

    /*  generate a BLACK & WHITE dithered version from 24 bits-RGB */
    if (pDoc->picType == PIC24)  {                             
        byte *p,*ep;
        for (i=pDoc->pWIDE * pDoc->pHIGH,p=pBWpic,ep=pDoc->pic;
             i;
             i--, p++, ep+=3)
          *p = (byte)( ( MONO(ep[0],ep[1],ep[2]) > threshold) ? 1 : 0  );
     }
    
    /*  generate a BLACK & WHITE version from colormapped image  */
    else if ( !pDoc->mono ) { /* ptype == PIC8 and not grayscaled */
        byte *p,*ep,table[256];
        for (i=255; i; ) {
            i--;
            table[i]= (MONO(pDoc->rMap[i],pDoc->gMap[i],pDoc->bMap[i]) 
                        > threshold) ? 1 : 0 ;
        }
        /* match colors to 0 (black) or 1 (white) */
        for (i=pDoc->pWIDE*pDoc->pHIGH, p=pBWpic, ep=pDoc->pic;
             i;
             i--, p++, ep++)
          *p = table[*ep];          
      }
    /*  generate a BLACK & WHITE version from greyscaled image  */
    else { /* grayscaled image => faster conversion than colormaped one */
        byte *p,*ep;
        /* match colors to 0 (black) or 1 (white) */
        for (i=pDoc->pWIDE*pDoc->pHIGH, p=pBWpic, ep=pDoc->pic;
             i;
             i--, p++, ep++) 
          *p = (*ep > threshold) ? 1 : 0 ;          
      }

  // Store provisional values
  pDoc->pic=pBWpic;
  pDoc->picType = PIC8;
  pDoc->mono = TRUE;
  pDoc->numcols = 2; 

  // Set Black & White colormap
  pDoc->rMap[0]=pDoc->gMap[0]=pDoc->bMap[0]=0;     // black
  pDoc->rMap[1]=pDoc->gMap[1]=pDoc->bMap[1]=255;   // white
  
  //Show pic
  pDoc->RedrawPic();

  // Restore original colormap if needed
  xvbcopy((char *)formerRmap, (char *)pDoc->rMap, 2);
  xvbcopy((char *)formerGmap, (char *)pDoc->gMap, 2);
  xvbcopy((char *)formerBmap, (char *)pDoc->bMap, 2);

  // RESTORE former values
  pDoc->pic=FormerPic;
  pDoc->picType=formerPicType;
  pDoc->mono = formerMono;
  pDoc->numcols = formerNumcols;
}


/*********************************************************************************/

void CDibDoc::ChangeImageFormat(int colType)
{
  if (colType != F_BWDITHER) {
    /* Do the format translation without user input*/
    IOfile::ChangeImageFormat(colType);
    return ;
  }
  
  /* Special tratament if image is being converted to black & white */

  /* return if there is nothing to do! */
  if (!pic || !pWIDE || !pHIGH || numcols == 2 ) return;
  /* allocate black & white image*/
  byte *pSave = (byte *) malloc((size_t) pWIDE * pHIGH);
  if (!pSave) {
    Error("Ha fallado el alojamiento de la imagen bicolor (GetImage)");
    return;
  }

  /* Do interactive dialog for black & white level threshold
   * adjustement */
  CFormaDlg dlg;
  dlg.pDoc = this;
  dlg.pBWpic = pSave;
  /* Show dialog */
  int button_pressed = dlg.DoModal();
  if (button_pressed == IDOK) {
    /* Instal BW version of image */
   //if (!dlg.pasoApaso) //Update Image is necesary.
      dlg.ShowImageInBW(dlg.threshold);

    StoreNewPic(pSave,PIC8/*picType*/,TRUE /*mono*/,
                pWIDE, pHIGH, 2 /*B&W*/);
  } else { /* button_pressed == IDCANCEL */
   /* free memory and leave original image */
   free(pSave);
   /* update display with original image */
   RedrawPic();
  }
}

/*********************************************************************************/


