// ImgDoc.h : interface of the CImgBasicDoc class

#ifndef _IMGBASICDOC_H
#define _IMGBASICDOC_H

#include "..\ImgBasic\ImgBasic.h"
#include "DibDoc.h"

class CImgBasicDoc : public CDibDoc, virtual public ImgBasic
{

public:
    const CImgBasicDoc* GetImgBasic() const { return this; };

// Constructor and destructor
protected:
  /*
  CImgBasicDoc() {SetImage((const IOfile*) this)};
  virtual ~CImgBasicDoc() {};
  */

protected: // create from serialization only
	DECLARE_DYNCREATE(CImgBasicDoc)

//Dialog user interface overridabled functions
public:
    virtual void AlgCanny  (void);
    virtual void Multires  (int type);
    virtual void CannyMRes (int type);
    virtual void ResizePic (void);
    virtual void CropPic   (void);
    virtual void Gamma     (void);
    virtual void Saturate       (void); 

// Generated message map functions
protected:
	//{{AFX_MSG(CImgBasicDoc)
  afx_msg void OnMirror() {FlipPic(0);}
	afx_msg void OnFlipVer() {FlipPic(1);}
	afx_msg void OnRotate90() {RotatePic(0);}
  afx_msg void OnRotate_90() {RotatePic(1);}
	afx_msg void OnInvert() {InvertPic();}
	afx_msg void OnAlgMedian() {DoAlg(ALG_MEDIAN);}
	afx_msg void OnAlgOil() {DoAlg(ALG_OIL);}
	afx_msg void OnAlgPixel() {DoAlg(ALG_PIXEL);}
	afx_msg void OnAlgRotate() {DoAlg(ALG_ROTATE);}
	afx_msg void OnAlgRotateclr() {DoAlg(ALG_ROTATECLR);}
	afx_msg void OnAlgSpread() {DoAlg(ALG_SPREAD);}
	afx_msg void OnAlgTinf() {DoAlg(ALG_TINF);}
	afx_msg void OnAlgSharpen() {DoAlg(ALG_SHARPEN);}
	afx_msg void OnAlgBlend() {DoAlg(ALG_BLEND);}
	afx_msg void OnAlgEdge() {DoAlg(ALG_EDGE);}
	afx_msg void OnAlgBlur() { DoAlg(ALG_BLUR); };
	afx_msg void OnNoiseGaussian() { DoAlg(ALG_GSNOISE); }
	afx_msg void OnBlurGaussian() { DoAlg(ALG_GSBLUR); }
	afx_msg void OnCrop() { DoAlg(ALG_CROP); }
	afx_msg void OnSmooth() { DoAlg(ALG_RESIZE); }
	afx_msg void OnMultiresgauss() { DoAlg(ALG_MULTIRES); }
	afx_msg void OnGradienteRoberts(){ DoAlg(ALG_GRAD_ROB); }
	afx_msg void OnAlgCanny()   { DoAlg(ALG_CANNY); }
	afx_msg void OnFastMultires() { DoAlg(ALG_FASTMRES); }
	afx_msg void OnAlgFmcanny() { DoAlg(ALG_CANYMRES); }
	afx_msg void OnAlgFmcanny4() { DoAlg(ALG_CANYMRES4); }
	afx_msg void OnGamma()  {DoAlg(ALG_GAMMA); }
	afx_msg void OnSaturate() { DoAlg(ALG_SATURATE); };
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //#define _IMGBASICDOC_H
