// mainfrm.cpp : implementation of the CMainFrame class
//

/* Proyecto Fin de Carrera
 * Departamento de Informatica e Ingeniera de Sistemas
 * Universidad de Zaragora
 *
 * rea:      Robtica y Automatizacin Avanzada.
 * Tema:      Visin por Computador.
 * Ttulo:    Diseo de un entorno de visin para 
 *            el tratamiento de imgenes.
 * Director:  Dr. Carlos Sags Blzquiz.
 * Autor:     Joaqun Mur Amada.
 * Promocin: 1991-1996.
*/

#include "stdafx.h"
#include "..\res\resource.h"
#include "VisioApp.h"

#include "mainfrm.h"
#include "Splash.h"

#include "ChildFrm.h"
#include "MultiFil.h"

#include "Registry.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#define _MAINFRAME_CPP_
#include "Toolbars.h"

/////////////////////////////////////////////////////////////////////////////
// CMainFrame


IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_PALETTECHANGED()
	ON_WM_QUERYNEWPALETTE()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_COMMAND(ID_AYUDA_CONTENIDO, OnAyudaContenido)
	ON_COMMAND(ID_AYUDA_MOSTRAR, OnAyudaMostrar)
 	ON_COMMAND(ID_FILE_OPEN_DIB, OnDibOpen)
	ON_COMMAND(ID_FILE_OPEN_IMG, OnImgOpen)
	ON_COMMAND(ID_FILE_OPEN_INSP, OnInspOpen)
	ON_WM_CLOSE()
	ON_COMMAND(ID_VIEW_TOOLBAR, OnToolbarMain)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBAR, OnUpdateToolbarMain)
	ON_COMMAND(ID_VIEW_TOOLBAR_DIB, OnToolbarDib)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBAR_DIB, OnUpdateToolbarDib)
	ON_COMMAND(ID_VIEW_TOOLBAR_IMG, OnToolbarImg)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBAR_IMG, OnUpdateToolbarImg)
	ON_COMMAND(ID_VIEW_TOOLBAR_INSP, OnToolbarInsp)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBAR_INSP, OnUpdateToolbarInsp)
	ON_WM_MENUSELECT()
	ON_WM_INITMENUPOPUP()
	ON_WM_SIZE()
	ON_COMMAND(ID_CAPTURE, OnCapture)
	ON_COMMAND(ID_CAPTURE_SETTINGS, OnCaptureSettings)
  ON_MESSAGE(WM_ENDCAPTURE,OnEndCapture)
	//}}AFX_MSG_MAP
  // Global help commands
	ON_COMMAND(ID_HELP_FINDER, CMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpFinder)
  /*
	// By making the Menu IDs that same as the ToolBar IDs
	// we can leverage off of code that is already provided
	// in MFCs implementation of CFrameWnd to check, uncheck
	// show and hide toolbars.
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBAR_DIB, OnUpdateControlBarMenu)
	ON_COMMAND_EX(ID_VIEW_TOOLBAR_DIB, OnBarCheck)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBAR_IMG, OnUpdateControlBarMenu)
	ON_COMMAND_EX(ID_VIEW_TOOLBAR_IMG, OnBarCheck)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBAR_INS, OnUpdateControlBarMenu)
	ON_COMMAND_EX(ID_VIEW_TOOLBAR_INS, OnBarCheck)
  */
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars


static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
	ID_TIME_INDICATOR           // time indicator
};

/////////////////////////////////////////////////////////////////////////////
// Helpers for saving/restoring window state

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
  	m_cxPaneWidth = -1;
	  m_bMenuSelected = FALSE;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{

  if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

 	// CG: The following line was added by the Splash Screen component.
	CSplashWnd::ShowSplashScreen(this);
	// End of SplasScreen

  /* Set last window position from registry */
	WINDOWPLACEMENT wp;
	if (LoadWindowPlacement (&wp))
	{
		wp.showCmd = AfxGetApp ()->m_nCmdShow;
		SetWindowPlacement (&wp);
	}
  
  if (!m_wndMainframeToolBar.Create(this) ||
		!m_wndMainframeToolBar.LoadBitmap(IDR_MAINFRAME_BAR) ||
		!m_wndMainframeToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

   if (!m_wndDibToolBar.Create(this) ||
		  !m_wndDibToolBar.LoadBitmap(IDR_DIB_BAR) ||
		  !m_wndDibToolBar.SetButtons(DibButtons,
		    sizeof(DibButtons)/sizeof(UINT)))
	  {
		  TRACE0("Failed to create toolbar\n");
		  return FALSE;      // fail to create
	  }

    if (!m_wndImgToolBar.Create(this) ||
		  !m_wndImgToolBar.LoadBitmap(IDR_IMGBASIC_BAR) ||
		  !m_wndImgToolBar.SetButtons(ImgButtons,
		    sizeof(ImgButtons)/sizeof(UINT)))
	  {
		  TRACE0("Failed to create toolbar\n");
		  return FALSE;      // fail to create
	  }
 
   if (!m_wndInspToolBar.Create(this) ||
		  !m_wndInspToolBar.LoadBitmap(IDR_INSPECTION_BAR) ||
		  !m_wndInspToolBar.SetButtons(InspButtons,
		    sizeof(InspButtons)/sizeof(UINT)))
	  {
		  TRACE0("Failed to create toolbar\n");
		  return FALSE;      // fail to create
	  }
  
  // Enable "tool tips"
		m_wndMainframeToolBar.SetBarStyle(m_wndMainframeToolBar.GetBarStyle() |
				CBRS_TOOLTIPS | CBRS_FLYBY  | CBRS_SIZE_DYNAMIC );
  // Make the main tool bar dockable
		m_wndMainframeToolBar.SetWindowText(_T("Estndar"));
    m_wndMainframeToolBar.EnableDocking(CBRS_ALIGN_ANY);
  // Show tool bar
    ShowControlBar(&m_wndMainframeToolBar, TRUE, FALSE);
	
  // Enable "tool tips" and don't be visible
		m_wndDibToolBar.SetBarStyle(m_wndDibToolBar.GetBarStyle()
				| CBRS_TOOLTIPS | CBRS_FLYBY  | CBRS_SIZE_DYNAMIC );	
  // Make the DibDoc tool bar dockable
		m_wndDibToolBar.SetWindowText(_T("DibDoc"));
    m_wndDibToolBar.EnableDocking(CBRS_ALIGN_ANY);
  // Hide tool bar
    ShowControlBar(&m_wndDibToolBar, FALSE, FALSE);
 	
  // Enable "tool tips" and don't be visible
		m_wndImgToolBar.SetBarStyle(m_wndImgToolBar.GetBarStyle() 
				| CBRS_TOOLTIPS | CBRS_FLYBY  | CBRS_SIZE_DYNAMIC );	
  // Make the ImgBasic tool bar dockable
    m_wndImgToolBar.SetWindowText(_T("ImgBasic"));
		m_wndImgToolBar.EnableDocking(CBRS_ALIGN_ANY);
   // Hide tool bar
   ShowControlBar(&m_wndImgToolBar, FALSE, FALSE);

	// Enable "tool tips" and not visible
		m_wndInspToolBar.SetBarStyle(m_wndInspToolBar.GetBarStyle()
				| CBRS_TOOLTIPS | CBRS_FLYBY  | CBRS_SIZE_DYNAMIC );	
  // Make the tool bar dockable
		m_wndInspToolBar.SetWindowText(_T("Inspection"));
		m_wndInspToolBar.EnableDocking(CBRS_ALIGN_ANY);
   // Hide tool bar
   ShowControlBar(&m_wndInspToolBar, FALSE, FALSE);

 	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
		EnableDocking(CBRS_ALIGN_ANY);
		DockControlBar(&m_wndMainframeToolBar);
		DockControlBar(&m_wndDibToolBar);
		DockControlBar(&m_wndImgToolBar);
		DockControlBar(&m_wndInspToolBar);

  // STATUS BAR
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}


  // LoadBarState loads everything but the number of Columns in the Palette
	// we need to do that ourseleves.
	LoadBarState("ControlBars\\State");

	// Create a timer (to update the time display on the status
  // bar once each minute)
	if (!SetTimer(PROG_TIMER, 60000, NULL))
	{
		MessageBox("Fall la inicializacin del temporizador (Timer)!",
					"Aplicacin DIBLOOK", MB_OK | MB_ICONEXCLAMATION);
	}

	CTime CurTime(time(NULL));
	m_wndStatusBar.SetPaneText(4,CurTime.Format(" %I:%M %p"));

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame commands


void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd)
{
	CMDIFrameWnd::OnPaletteChanged(pFocusWnd);

	// always realize the palette for the active view
	CMDIChildWnd* pMDIChildWnd = MDIGetActive();
	if (pMDIChildWnd == NULL)
		return; // no active MDI child frame
	CView* pView = pMDIChildWnd->GetActiveView();
	ASSERT(pView != NULL);

	// notify all child windows that the palette has changed
	SendMessageToDescendants(WM_DOREALIZE, (WPARAM)pView->m_hWnd);
}



BOOL CMainFrame::OnQueryNewPalette()
{
	// always realize the palette for the active view
	CMDIChildWnd* pMDIChildWnd = MDIGetActive();
	if (pMDIChildWnd == NULL)
		return FALSE; // no active MDI child frame (no new palette)
	CView* pView = pMDIChildWnd->GetActiveView();
	ASSERT(pView != NULL);

	// just notify the target view
	pView->SendMessage(WM_DOREALIZE, (WPARAM)pView->m_hWnd);
	return TRUE;
}

void CMainFrame::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == PROG_TIMER) {	
    if (m_wndStatusBar.Finished()) {
        //Progress meter is not shown
		  // A second (1000 msec) has been gone out
		  CTime CurTime(time(NULL));
		  m_wndStatusBar.SetPaneText(4,CurTime.Format(" %I:%M %p"));
    } else {
      // The progress meter is showing, so don't paint
      // in the last pane of main frame.
      //m_wndStatusBar.ShowProgress();
    }
  }
  // Do default timer event processing, too.
  CMDIFrameWnd::OnTimer(nIDEvent);
}

void CMainFrame::OnAyudaMostrar() 
{
	// TODO: Add your command handler code here
	::WinHelp(NULL,"HLP.HLP>main",HELP_FINDER,0);
}

void CMainFrame::OnAyudaContenido() 
{
	// TODO: Add your command handler code here
	::WinHelp(GetSafeHwnd(),"HLP.HLP>main",HELP_FINDER,0);	
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnClose()
{
	WINDOWPLACEMENT wp;
	if (GetWindowPlacement (&wp))
	{
		if (IsZoomed ())
			wp.flags |= WPF_RESTORETOMAXIMIZED;

		SaveWindowPlacement (&wp);
	}
	CMDIFrameWnd::OnClose ();
}

BOOL CMainFrame::LoadWindowPlacement(LPWINDOWPLACEMENT pwp)
{
  // Load capture settings
  CCaptureDlg::InitializeStaticData();
  
  CString strBuffer = AfxGetApp ()->GetProfileString ("Settings", "WindowPos");

	if (strBuffer.IsEmpty ())
		return FALSE;

	int cRead = _stscanf (strBuffer, "%i:%i:%i:%i:%i:%i:%i:%i:%i:%i",
			&pwp->flags, &pwp->showCmd,
			&pwp->ptMinPosition.x, &pwp->ptMinPosition.y,
			&pwp->ptMaxPosition.x, &pwp->ptMaxPosition.y,
			&pwp->rcNormalPosition.left, &pwp->rcNormalPosition.top,
			&pwp->rcNormalPosition.right, &pwp->rcNormalPosition.bottom);

	if (cRead != 10)
		return FALSE;

	return TRUE;

}

void CMainFrame::SaveWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	// SaveBarState saves Toolbars state
	// we need to do that ourseleves.
	SaveBarState("ControlBars\\State");

  // SaveWindowPlacement
	CString strBuffer;
	strBuffer.Format ("%i:%i:%i:%i:%i:%i:%i:%i:%i:%i",
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom);

	AfxGetApp ()->WriteProfileString ("Settings", "WindowPos", strBuffer);
	// end of insert
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame commands


void CMainFrame::OnDibOpen()
{
  CVisioApp* pApp = (CVisioApp*) AfxGetApp();
  pApp->m_nNewDocType = DOCTYPE_CDIBDOC;

  // prompt the user (with all document templates)
	CMultiFileDialog dlgFile(TRUE);
	CString title,strFilter,strDefault;
	VERIFY(title.LoadString(AFX_IDS_OPENFILE));
	
	dlgFile.m_ofn.Flags |= OFN_HIDEREADONLY | OFN_FILEMUSTEXIST 
                       | OFN_ALLOWMULTISELECT;
//	dlgFile.m_ofn.Flags &= ~OFN_SHOWHELP;

  dlgFile.m_ofn.nFilterIndex = 1;
	// strDefExt is necessary to hold onto the memory from GetExtFromType
	dlgFile.m_ofn.lpstrDefExt = NULL;
		
	// do for all doc template
	AppendFilterSuffix (strFilter, dlgFile.m_ofn, pApp->m_pTemplateIOfile,
		&strDefault);

	// append the "*.*" all files filter
	CString allFilter;
	VERIFY(allFilter.LoadString(AFX_IDS_ALLFILTER));
	strFilter += allFilter;
	strFilter += (TCHAR)'\0';   // next string please
	strFilter += _T("*.*");
	strFilter += (TCHAR)'\0';   // last string
	dlgFile.m_ofn.nMaxCustFilter++;

	dlgFile.m_ofn.lpstrFilter = strFilter;
	dlgFile.m_ofn.lpstrTitle = title;
	dlgFile.m_ofn.hwndOwner = AfxGetMainWnd()->GetSafeHwnd();

	if (dlgFile.DoModal() == IDOK)
	{
		POSITION pos = dlgFile.GetStartPosition();
		while (pos != NULL)
		{
			CString strPath = dlgFile.GetNextPathName(pos);
			if (strPath.Find(":\\\\") == 1 && strPath.GetLength() > 4)
			{
				// this means we have an invalid path that looks like this:
				// C:\\foo.bmp
				// We need to cut out the extra slash
				CString temp;
				temp = strPath.Left(3);
				temp += strPath.Mid(4);
				strPath = temp;
			}

      pApp->m_pTemplateIOfile->OpenDocumentFile(strPath);
		}
  }
	// the default PostNcDestroy handler will delete this object when destroyed
}

void CMainFrame::OnImgOpen()
{
  CVisioApp* pApp = (CVisioApp*) AfxGetApp();
  pApp->m_nNewDocType = DOCTYPE_CIMGBASICDOC;
  
  // prompt the user (with all document templates)
	CMultiFileDialog dlgFile(TRUE);
	CString title,strFilter,strDefault;
	VERIFY(title.LoadString(AFX_IDS_OPENFILE));
	
	dlgFile.m_ofn.Flags |= OFN_HIDEREADONLY | OFN_FILEMUSTEXIST 
                       | OFN_ALLOWMULTISELECT;
//	dlgFile.m_ofn.Flags &= ~OFN_SHOWHELP;

  dlgFile.m_ofn.nFilterIndex = 1;
	// strDefExt is necessary to hold onto the memory from GetExtFromType
	dlgFile.m_ofn.lpstrDefExt = NULL;
		
	// do for all doc template
	AppendFilterSuffix (strFilter, dlgFile.m_ofn, pApp->m_pTemplateImgBasic,
		&strDefault);

	// append the "*.*" all files filter
	CString allFilter;
	VERIFY(allFilter.LoadString(AFX_IDS_ALLFILTER));
	strFilter += allFilter;
	strFilter += (TCHAR)'\0';   // next string please
	strFilter += _T("*.*");
	strFilter += (TCHAR)'\0';   // last string
	dlgFile.m_ofn.nMaxCustFilter++;

	dlgFile.m_ofn.lpstrFilter = strFilter;
	dlgFile.m_ofn.lpstrTitle = title;
	dlgFile.m_ofn.hwndOwner = AfxGetMainWnd()->GetSafeHwnd();

	if (dlgFile.DoModal() == IDOK)
	{
		POSITION pos = dlgFile.GetStartPosition();
		while (pos != NULL)
		{
			CString strPath = dlgFile.GetNextPathName(pos);
			if (strPath.Find(":\\\\") == 1 && strPath.GetLength() > 4)
			{
				// this means we have an invalid path that looks like this:
				// C:\\foo.bmp
				// We need to cut out the extra slash
				CString temp;
				temp = strPath.Left(3);
				temp += strPath.Mid(4);
				strPath = temp;
			}

      pApp->m_pTemplateImgBasic->OpenDocumentFile(strPath);
		}
  }
  // the default PostNcDestroy handler will delete this object when destroyed
}

void CMainFrame::OnInspOpen() 
{
	// TODO: Add your command handler code here
  CVisioApp* pApp = (CVisioApp*) AfxGetApp();
  pApp->m_nNewDocType = DOCTYPE_CIMGBASICDOC;
  
  // prompt the user (with all document templates)
	CMultiFileDialog dlgFile(TRUE);
	CString title,strFilter,strDefault;
	VERIFY(title.LoadString(AFX_IDS_OPENFILE));
	
	dlgFile.m_ofn.Flags |= OFN_HIDEREADONLY | OFN_FILEMUSTEXIST 
                       | OFN_ALLOWMULTISELECT;
//	dlgFile.m_ofn.Flags &= ~OFN_SHOWHELP;

  dlgFile.m_ofn.nFilterIndex = 1;
	// strDefExt is necessary to hold onto the memory from GetExtFromType
	dlgFile.m_ofn.lpstrDefExt = NULL;
		
	// do for all doc template
	AppendFilterSuffix (strFilter, dlgFile.m_ofn, pApp->m_pTemplateInspection,
		&strDefault);

	// append the "*.*" all files filter
	CString allFilter;
	VERIFY(allFilter.LoadString(AFX_IDS_ALLFILTER));
	strFilter += allFilter;
	strFilter += (TCHAR)'\0';   // next string please
	strFilter += _T("*.*");
	strFilter += (TCHAR)'\0';   // last string
	dlgFile.m_ofn.nMaxCustFilter++;

	dlgFile.m_ofn.lpstrFilter = strFilter;
	dlgFile.m_ofn.lpstrTitle = title;
	dlgFile.m_ofn.hwndOwner = AfxGetMainWnd()->GetSafeHwnd();

	if (dlgFile.DoModal() == IDOK)
	{
		POSITION pos = dlgFile.GetStartPosition();
		while (pos != NULL)
		{
			CString strPath = dlgFile.GetNextPathName(pos);
			if (strPath.Find(":\\\\") == 1 && strPath.GetLength() > 4)
			{
				// this means we have an invalid path that looks like this:
				// C:\\foo.bmp
				// We need to cut out the extra slash
				CString temp;
				temp = strPath.Left(3);
				temp += strPath.Mid(4);
				strPath = temp;
			}

      pApp->m_pTemplateInspection->OpenDocumentFile(strPath);
		}
  }
  // the default PostNcDestroy handler will delete this object when destroyed
	
}

void CMainFrame::OnToolbarMain() 
{
	// TODO: Add your command update UI handler code here
  BOOL visible = ((m_wndMainframeToolBar.GetStyle() & WS_VISIBLE) != 0);
	ShowControlBar(&m_wndMainframeToolBar, !visible, FALSE);
	m_wndMainframeToolBar.Invalidate();
}

void CMainFrame::OnUpdateToolbarMain(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
  pCmdUI->SetCheck((m_wndMainframeToolBar.GetStyle() & WS_VISIBLE) != 0);
}

void CMainFrame::OnToolbarDib() 
{
	// If the style says the ToolBar is visible then it is visible.
  BOOL visible = ((m_wndDibToolBar.GetStyle() & WS_VISIBLE) != 0);
	ShowControlBar(&m_wndDibToolBar, !visible, FALSE);
	m_wndDibToolBar.Invalidate();
}

void CMainFrame::OnToolbarImg() 
{
	// If the style says the ToolBar is visible then it is visible.
  BOOL visible = ((m_wndImgToolBar.GetStyle() & WS_VISIBLE) != 0);
	ShowControlBar(&m_wndImgToolBar, !visible, FALSE);
	m_wndImgToolBar.Invalidate();
}

void CMainFrame::OnToolbarInsp() 
{
	// If the style says the ToolBar is visible then it is visible.
  BOOL visible = ((m_wndInspToolBar.GetStyle() & WS_VISIBLE) != 0);
	ShowControlBar(&m_wndInspToolBar,!visible, FALSE);
	m_wndInspToolBar.Invalidate();
}

void CMainFrame::OnUpdateToolbarDib(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
  pCmdUI->SetCheck((m_wndDibToolBar.GetStyle() & WS_VISIBLE) != 0);
  //pCmdUI->Enable((CDibFrame::m_menu.m_hMenu == NULL));
}

void CMainFrame::OnUpdateToolbarImg(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
  pCmdUI->SetCheck((m_wndImgToolBar.GetStyle() & WS_VISIBLE) != 0);
  //pCmdUI->Enable((CImgFrame::m_menu.m_hMenu == NULL));
}

void CMainFrame::OnUpdateToolbarInsp(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
  pCmdUI->SetCheck((m_wndInspToolBar.GetStyle() & WS_VISIBLE) != 0);
  //pCmdUI->Enable((CInspectionFrame::m_menu.m_hMenu == NULL));
}
////////////////////////////////////////////////////////////////////////

void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	CFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);

	// store width of first pane and its style
	if (m_cxPaneWidth == -1 && m_bMenuSelected)
	{
		m_wndStatusBar.GetPaneInfo(0, m_nPaneID, 
			m_nPaneStyle, m_cxPaneWidth);

		// set the first pane's width to a very large number
		m_wndStatusBar.SetPaneInfo(0, m_nPaneID, 
			SBPS_NOBORDERS|SBPS_STRETCH, 10000);
	}
}

void CMainFrame::OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu) 
{
	CFrameWnd::OnMenuSelect(nItemID, nFlags, hSysMenu);

	// Restore first pane of the statusbar?
	if (nFlags == 0xFFFF && hSysMenu == 0 && m_cxPaneWidth != -1)
	{
		// The menu was closed (see help on OnMenuSelect), so restore
		// the first pane to it's original value

		m_bMenuSelected = FALSE;
		m_wndStatusBar.SetPaneInfo(0, m_nPaneID, 
			m_nPaneStyle, m_cxPaneWidth);

		m_cxPaneWidth = -1;   // Set it to illegal value
	}
	else 
	{
		m_bMenuSelected = TRUE;
	}
}

void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CMDIFrameWnd::OnSize(nType, cx, cy);
	// TODO: Add your message handler code here
  if (m_wndStatusBar.GetSafeHwnd())
	{
 		/*if (!m_wndStatusBar.Finished()) {
      int aWidths[4] = {cx/2, -1};
		   m_wndStatusrBar.SetParts(2, aWidths);
    }*/
		m_wndStatusBar.SendMessage(WM_SIZE, nType, MAKELONG(cy, cx));
	}
}



