// MeterBar.cpp : implementation file
//

#include "stdafx.h"
#include "VisioApp.h"
#include "MeterBar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#undef SHOW_PROGRESS_TEXT
//#define SHOW_PROGRESS_TEXT

/////////////////////////////////////////////////////////////////////////////
// CMeterBar

CMeterBar::CMeterBar() :
  m_min(0), m_max(10), m_val(10),
  m_InProgress(FALSE)
{
  strcpy(m_message,"Ten paciencia...");
}

CMeterBar::~CMeterBar()
{
}


BEGIN_MESSAGE_MAP(CMeterBar, CStatusBar)
	//{{AFX_MSG_MAP(CMeterBar)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMeterBar message handlers

int CMeterBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CStatusBar::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_meter.Create(WS_CHILD /*| WS_VISIBLE*/, CRect(0,0,0,0), this, 101);
	m_meter.SetRange(m_min, m_max);
	m_meter.SetPos(m_val);
	m_meter.SetStep(1);
	
	return 0;
}

void CMeterBar::OnSize(UINT nType, int cx, int cy) 
{
	CStatusBar::OnSize(nType, cx, cy);
	
	// Assume the last pane in the control is used for the meter
  CStatusBarCtrl& rStatusCtrl = GetStatusBarCtrl();

#ifdef SHOW_PROGRESS_TEXT
	int nTemp;
	int nCount = rStatusCtrl.GetParts(0, &nTemp);

	if (nCount > 0) {
		CRect r;
		rStatusCtrl.GetRect(nCount - 1, r);
    /* empieza a mitad de la barra de control */
    r.left = cx/2;
		m_meter.MoveWindow(r);
  }
#else //SHOW_PROGRESS_TEXT
    /* Get first and last pane */
    CRect firstPane, lastPane;
    rStatusCtrl.GetRect(0, firstPane);
    rStatusCtrl.GetRect(m_nIDCount - 1, lastPane);
    /* ocupa toda la barra de control */
    lastPane.left = firstPane.left;
		m_meter.MoveWindow(lastPane);
#endif //SHOW_PROGRESS_TEXT
}

void CMeterBar::SetPos(int pos)
{
  if (pos<m_min) m_val = m_min;
  else if (pos>=m_max) {
    m_val = m_max;
    if (m_InProgress) {
      HideProgress();
    }
  } else {
    m_val=pos; 
    if (!m_InProgress) {
      InitProgress();
    }
    ShowProgress();
  }
}

void CMeterBar::InitProgress()
{
    m_InProgress=TRUE;
#ifdef SHOW_PROGRESS_TEXT
    //SetPaneText(0, m_message, FALSE);
#endif //SHOW_PROGRESS_TEXT
    /* Change size of panes */
    CRect rect;
    GetClientRect( &rect );
    ASSERT(m_nIDCount==5);
    /* Strech last pane */
    SetPaneInfo(0,ID_SEPARATOR,SBPS_POPOUT,rect.right/2);
    SetPaneInfo(1,ID_SEPARATOR,SBPS_DISABLED,0);
    SetPaneInfo(2,ID_SEPARATOR,SBPS_DISABLED,0);
    SetPaneInfo(3,ID_SEPARATOR,SBPS_DISABLED,0);
    SetPaneInfo(4,IDS_PROGRESS_INDICATOR,SBPS_STRETCH || SBPS_NOBORDERS,
      /*-1*/ rect.right/2);
    /* Show Progress Bar */
#ifdef SHOW_PROGRESS_TEXT
    //SetWindowText(m_message);
    SetPaneText(0, m_message, FALSE);
    OnPaint( ); /* Paint Text now (don't wait to idle state) */
    UpdateAllPanes(TRUE, TRUE);
#endif //SHOW_PROGRESS_TEXT
    m_meter.ShowWindow(SW_SHOW);
#ifdef SHOW_PROGRESS_TEXT
    /* Update text */
    //SetPaneText(0, m_message);
    //SetWindowText(m_message);    
    //SetPaneText(0, m_message, TRUE);
#endif //SHOW_PROGRESS_TEXT
}

void CMeterBar::HideProgress()
{
    /* Hide Progress Bar */
    m_meter.ShowWindow(SW_HIDE);
    //CStatusBar::GetStatusBarCtrl().SetParts(m_nIDCount, m_cxPaneWidth);
    for(int i=m_nIDCount;i;) {
      i--;
      SetPaneInfo(i,m_nPaneID[i],m_nPaneStyle[i],m_cxPaneWidth[i]);
    }
    m_val = m_max;
    SetWindowText("Proceso terminado!");
    m_InProgress = FALSE;
}

void CMeterBar::ShowProgress()
{
  if (!m_InProgress && m_val<m_max) InitProgress();
  else if (m_val >= m_max) {
    HideProgress();
    return;
  }
  m_meter.SetRange(m_min, m_max);
	m_meter.SetPos(m_val);
  //SetWindowText(m_message);    
}

void CMeterBar::ProgressMeter(int min, int max, int val, char *str)
{
  m_min = min;
  m_max = max;
#ifdef SHOW_PROGRESS_TEXT
  if (m_message != NULL)
    strcpy(m_message, str);
#endif //SHOW_PROGRESS_TEXT
  SetPos(val);
}

BOOL CMeterBar::SetIndicators(const UINT* lpIDArray, int nIDCount)
{
  BOOL bResult = CStatusBar::SetIndicators( lpIDArray, nIDCount);
  for(int i=m_nIDCount=nIDCount;i;) {
    i--;
    GetPaneInfo(i,m_nPaneID[i],m_nPaneStyle[i],m_cxPaneWidth[i]);
  }
  /* progress bar not shown */
  m_InProgress=FALSE;
  return bResult;
}
