// Registry.cpp : implementation file
//

#include "stdafx.h"
#include "..\res\resource.h"
#include "Registry.h"
#include "Regkey.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCaptureDlg dialog

CString CCaptureDlg::strCapturador = _T("");
CString CCaptureDlg::strFichero    = _T("");
BOOL    CCaptureDlg::bPreguntar    = FALSE;

CCaptureDlg::CCaptureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCaptureDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCaptureDlg)
	m_strCapturador = strCapturador;
  m_strFichero = strFichero;
  m_bPreguntar = bPreguntar;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCaptureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCaptureDlg)
	DDX_Text(pDX, IDC_CAPTURER, m_strCapturador);
 	DDX_Text(pDX, IDC_FILE, m_strFichero);
	DDX_Check(pDX, IDC_PREGUNTAR, m_bPreguntar);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCaptureDlg, CDialog)
	//{{AFX_MSG_MAP(CCaptureDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_BN_CLICKED(IDBROWSE_CAPTURER, OnBrowseCapturer)
	ON_BN_CLICKED(IDBROWSE_FILE, OnBrowseFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCaptureDlg message handlers

BOOL CCaptureDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

  // Open registry key.
	CRegKey regKey;
	long lResult = regKey.Open(HKEY_CURRENT_USER, 
		_T("Software\\Joaquin_Mur"));

	// Get contents of registered owner value.
	if (lResult == ERROR_SUCCESS)
	{
		regKey.Read(_T("CapturadorImagnes"), m_strCapturador);
 	  strCapturador = m_strCapturador;
		regKey.Read(_T("FicheroCapturado"), m_strFichero);
    strFichero    = m_strFichero;
    unsigned long preguntar;
    regKey.Read(_T("PreguntarFichero"), preguntar);
    m_bPreguntar = bPreguntar = preguntar;
		UpdateData(FALSE);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// Set static data without showing the dialog
void CCaptureDlg::InitializeStaticData()
{
  // Open registry key.
	CRegKey regKey;
	long lResult = regKey.Open(HKEY_CURRENT_USER, 
		_T("Software\\Joaquin_Mur"));

	// Get contents of registered owner value.
	if (lResult == ERROR_SUCCESS)
	{
		regKey.Read(_T("CapturadorImagnes"), strCapturador);
		regKey.Read(_T("FicheroCapturado"), strFichero);
    unsigned long preguntar;
    regKey.Read(_T("PreguntarFichero"), preguntar);
    bPreguntar = preguntar;
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCaptureDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCaptureDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CCaptureDlg::OnApply() 
{
	// Open registry key.
	CRegKey regKey;
	long lResult = regKey.Open(HKEY_CURRENT_USER, 
		_T("Software\\Joaquin_Mur"));
	// Write contents of edit control to registry.
	if (lResult == ERROR_SUCCESS)
	{
		UpdateData(TRUE);
		regKey.Write(_T("CapturadorImagnes"), m_strCapturador);
 	  strCapturador = m_strCapturador;
		regKey.Write(_T("FicheroCapturado"),  m_strFichero);
    strFichero    = m_strFichero;
    regKey.Write(_T("PreguntarFichero"), (DWORD) m_bPreguntar);
    bPreguntar = m_bPreguntar;
	} 
  OnOK();
}

void CCaptureDlg::OnBrowseCapturer() 
{
		CFileDialog dlgFile(TRUE, NULL, NULL, 
		OFN_HIDEREADONLY, _T("Aplicaciones de captura (*.EXE)|*.EXE;*.COM||"));

	// If select file, allocate memory to hold path name. This is very
	// important since the thread function will access this address
	// after this function has terminated. It is the responsibility of
	// the thread function to free the memory for the path name.
	if (dlgFile.DoModal() == IDOK)	
	{
		// Allocate structure that will pass relevant information
		// to the thread function. The thread function is responsible
		// for freeing the structure.
		m_strCapturador = dlgFile.GetPathName();
    UpdateData(FALSE);
	}
}

void CCaptureDlg::OnBrowseFile() 
{
  CFileDialog dlgFile(TRUE, NULL, NULL, 
		OFN_HIDEREADONLY, _T("Imgenes|*..BMP;*.DIB;*.GIF;*.IFF;"
    "*.JIF;*.JPG;*.PBM;*.PCX;*.PDS;*.PGM;*.PM;*.PPM;*.PXM;*.RAS;"
    "*.RAW;*.RGB;*.RLE;*.TGA;*.TIF;*.XWD;*.XBM;*.XPM;*.XWD||"));

	// If select file, allocate memory to hold path name. This is very
	// important since the thread function will access this address
	// after this function has terminated. It is the responsibility of
	// the thread function to free the memory for the path name.
	if (dlgFile.DoModal() == IDOK)	
	{
		// Allocate structure that will pass relevant information
		// to the thread function. The thread function is responsible
		// for freeing the structure.
		m_strFichero = dlgFile.GetPathName();
    UpdateData(FALSE);
	}
}
