/*********************************************************************************\
*     File:                  R E S I Z D L G . C P P                              *
\*********************************************************************************/
/*
 * crop.cpp: algoritms to change image size without cropping (like a zoom)
 *
 *  Contains:
 *         void ResizePic();
 *         void CropPic  ();
 */

#include "stdafx.h"
#include "..\\res\\resource.h"
#include "ImgDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCropDlg dialog

class CCropDlg : public CDialog
{
public:
  int sx, sy, sh, sw;
// Construction
public:
	CCropDlg( int SH, int SW,  int SX = NULL, int SY = NULL,
             CWnd* pParent = NULL);   // copy constructor
// Dialog Data
protected:
	//{{AFX_DATA(CCropDlg)
	enum  { IDD = IDD_CROPIMAGE };
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCropDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CCropDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnHelp();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/*********************************************************************************/

/////////////////////////////////////////////////////////////////////////////
// CCropDlg dialog

CCropDlg::CCropDlg( int SH, int SW,  int SX/*0*/, int SY/*0*/,
                      CWnd* pParent /*=NULL*/)
	: CDialog(CCropDlg::IDD, pParent),
  sx(SX), sy (SY), sh(SH), sw(SW)
{
	//{{AFX_DATA_INIT(CCropDlg)
		// NOTE: the ClassWizard will add member initialization here
 	
	//}}AFX_DATA_INIT
}

BOOL CCropDlg::OnInitDialog() 
{
    CString Str;
    CSliderCtrl* pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_IZDA);
    pSlider->SetRange(0, sw);
    pSlider->SetPos(0);
    SetDlgItemText(IDC_STATIC_IZDA, "0");

    pSlider = (CSliderCtrl*) GetDlgItem(IDC_DCHA);
    pSlider->SetRange(0, sw);
    pSlider->SetPos(sw);
    Str.Format("%d", sw);
    SetDlgItemText(IDC_STATIC_DCHA, Str);

    pSlider = (CSliderCtrl*) GetDlgItem(IDC_SUP);
    pSlider->SetRange(0, sh);
    pSlider->SetPos(0);
    SetDlgItemText(IDC_STATIC_SUP, "0");

    pSlider = (CSliderCtrl*) GetDlgItem(IDC_INF);
    pSlider->SetRange(0, sh);
    pSlider->SetPos(sh);
    Str.Format("%d", sh);
    SetDlgItemText(IDC_STATIC_INF, Str);

    return CDialog::OnInitDialog();
}

void CCropDlg::DoDataExchange(CDataExchange* pDX)
{ 
  /* if (pDX->m_bSaveAndValidate)==FALSE
   * Uptate local variables with persistent ones
   * and update dialog controls */
  if (!(pDX->m_bSaveAndValidate)) {
    ((CSliderCtrl*) GetDlgItem(IDC_IZDA))
             ->SetPos(sx);
    ((CSliderCtrl*) GetDlgItem(IDC_DCHA))
             ->SetPos(sx+sw);
    ((CSliderCtrl*) GetDlgItem(IDC_SUP))
             ->SetPos(sy);
    ((CSliderCtrl*) GetDlgItem(IDC_INF))
             ->SetPos(sy+sh);
    }

  CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCropDlg)
	//}}AFX_DATA_MAP
    
  /* if (pDX->m_bSaveAndValidate)==TRUE
   * Uptate static variables with dialog values
   * For example, when OK button is pressed
   */
  if (pDX->m_bSaveAndValidate) {
    sx = ((CSliderCtrl*) GetDlgItem(IDC_IZDA))
             ->GetPos();
    sw = ((CSliderCtrl*) GetDlgItem(IDC_DCHA))
             ->GetPos() - sx;
    sy = ((CSliderCtrl*) GetDlgItem(IDC_SUP))
             ->GetPos();
    sh = ((CSliderCtrl*) GetDlgItem(IDC_INF))
             ->GetPos() - sy;
  }
}

BEGIN_MESSAGE_MAP(CCropDlg, CDialog)
	//{{AFX_MSG_MAP(CCropDlg)
	ON_BN_CLICKED(IDC_HELP_CANY, OnHelp)
  ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCropDlg message handlers


void CCropDlg::OnHelp() 
{
  MessageBox("La ayuda no est todava a punto","Ayuda");
}


void CCropDlg::OnHScroll(UINT nSBCode, UINT nPos,
                             CScrollBar* pScrollBar) 
{
    CSliderCtrl* pSlide = (CSliderCtrl*) pScrollBar;
    
    CString strText;
     strText.Format("%d", pSlide->GetPos());
    
   // four trackbars are sending
   // HSCROLL messages (different processing)
   switch(pScrollBar->GetDlgCtrlID()) {

    case IDC_IZDA:
        SetDlgItemText(IDC_STATIC_IZDA, strText);
        {
          CSliderCtrl* pS2 = (CSliderCtrl*) GetDlgItem (IDC_DCHA);
          if (pSlide->GetPos() > pS2->GetPos()) {
             pS2->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_DCHA, strText);
          }
        }

        break;

    case IDC_DCHA:
      SetDlgItemText(IDC_STATIC_DCHA, strText);
        {
          CSliderCtrl* pS2 = (CSliderCtrl*) GetDlgItem (IDC_IZDA);
          if (pSlide->GetPos() < pS2->GetPos()) {
             pS2->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_IZDA, strText);
          }
        }
      break;

    case IDC_SUP:
      SetDlgItemText(IDC_STATIC_SUP, strText);
        {
          CSliderCtrl* pS2 = (CSliderCtrl*) GetDlgItem (IDC_INF);
          if (pSlide->GetPos() > pS2->GetPos()) {
             pS2->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_INF, strText);
          }
        }
      break;

    case IDC_INF:
      SetDlgItemText(IDC_STATIC_INF, strText);
        {
          CSliderCtrl* pS2 = (CSliderCtrl*) GetDlgItem (IDC_SUP);
          if (pSlide->GetPos() < pS2->GetPos()) {
             pS2->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_SUP, strText);
          }
        }
      break;

    }
}

/////////////////////////////////////////////////////////////////////////////
// CResizeDlg dialog

class CResizeDlg : public CDialog
{
// Construction
public:
	CResizeDlg( int Height, int Width,
             CWnd* pParent = NULL);   // copy constructor
// Dialog Data
public:
	//{{AFX_DATA(CResizeDlg)
	enum { IDD = IDD_RESIZEIMAGE };
	int		m_height;
	int		m_width;
	CString	m_StringHeight;
	CString	m_StringWidth;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CResizeDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CResizeDlg)
	afx_msg void OnHelp();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/*********************************************************************************/

/////////////////////////////////////////////////////////////////////////////
// CResizeDlg dialog

#define MAX_HEIGHT 10000
#define MAX_WIDTH  10000

CResizeDlg::CResizeDlg( int Height, int Width, CWnd* pParent /*=NULL*/)
	: CDialog(CResizeDlg::IDD, pParent),
  m_height(Height), m_width (Width)
{
	//{{AFX_DATA_INIT(CResizeDlg)
	//}}AFX_DATA_INIT
  m_StringHeight.Format("Altura original: %d",Height);
  m_StringWidth.Format("Anchura original: %d",Width);
}

void CResizeDlg::DoDataExchange(CDataExchange* pDX)
{ 
  CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CResizeDlg)
	DDX_Text(pDX, IDC_EDIT_HEIGHT, m_height);
	DDV_MinMaxInt(pDX, m_height, 0, MAX_HEIGHT);
	DDX_Text(pDX, IDC_EDIT_WIDTH, m_width);
	DDV_MinMaxInt(pDX, m_width, 0, MAX_WIDTH);
	DDX_Text(pDX, IDC_STATIC_HEIGHT, m_StringHeight);
	DDX_Text(pDX, IDC_STATIC_WIDTH, m_StringWidth);
	//}}AFX_DATA_MAP
}
/*********************************************************************************/

BOOL CResizeDlg::OnInitDialog() 
{
  CDialog::OnInitDialog();
	// TODO: Add extra initialization here
 	CSpinButtonCtrl* pSpin = (CSpinButtonCtrl*)
     GetDlgItem(IDC_SPIN_HEIGHT);
  pSpin->SetRange(1,MAX_HEIGHT);
  pSpin->SetPos(m_height);

 	pSpin = (CSpinButtonCtrl*)
     GetDlgItem(IDC_SPIN_WIDTH);
  pSpin->SetRange(1,MAX_WIDTH);
  pSpin->SetPos(m_width);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BEGIN_MESSAGE_MAP(CResizeDlg, CDialog)
	//{{AFX_MSG_MAP(CResizeDlg)
	ON_BN_CLICKED(IDC_HELP_CANY, OnHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CResizeDlg message handlers


void CResizeDlg::OnHelp() 
{
  MessageBox("La ayuda no est todava a punto","Ayuda");
}

/*********************************************************************************/
void CImgBasicDoc::CropPic(void)
{
  byte* newpic;
  int resultado;

  CCropDlg dlg(pWIDE,pHIGH);

  resultado = dlg.DoModal();

  /* do nothing if cancel button is pressed */
  if (resultado == IDCANCEL) return;

  clock_t start = clock();
  newpic = XVGetSubImage(pic,picType,pWIDE,pHIGH,
              dlg.sx,dlg.sy,dlg.sw,dlg.sh);
  ElapsedTime("CropPic", start);

  if (newpic) {
    StoreNewPic(newpic, picType, mono, dlg.sw, dlg.sh, numcols);
    RedrawPic(); // Display new picture
  }
}
/*********************************************************************************/

void CImgBasicDoc::ResizePic(void)
{
  int resultado;

  CResizeDlg dlg(pWIDE,pHIGH);

  resultado = dlg.DoModal();

  /* do nothing if cancel button is pressed */
  if (resultado == IDCANCEL) return;

  clock_t start = clock();
  byte *pic24 = Smooth24(pic,picType,pWIDE,pHIGH, dlg.m_width,  
             dlg.m_height,rMap,gMap,bMap);
  ElapsedTime("ResizePic", start);

  if (pic24) {
    StoreNewPic(pic24, PIC24, FALSE, dlg.m_width, dlg.m_height, 0);
    RedrawPic(); // Display new image
  } else {
    Error("Smooth24 ha fallado");
    return;
  }	
}
/**************************************************************************************/