// Saturate.cpp : Contains
//                           CDibDoc::Saturate
//                           implementation
//

#include "stdafx.h"
#include "..\\res\\resource.h"
#include "Imgdoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CSaturateDlg dialog

class CSaturateDlg : public CDialog
{
public:
    static int   threshold;
    static BOOL  pasoApaso;

    /* Owner document */
    CImgBasicDoc *pDoc;
    /* Pointer to where new black & white image is wrote */
    byte *pBWpic;
    /* Modified colormap */
    byte red[256],green[256],blue[256];

// Construction
public:
	CSaturateDlg(CWnd* pParent = NULL);   // copy constructor
  void ShowImageInBW (int threshold);
// Dialog Data
protected:
	//{{AFX_DATA(CSaturateDlg)
	enum  { IDD = IDD_SATURATE };
  BOOL  m_PasoApaso;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSaturateDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSaturateDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnHelp();
	afx_msg void OnSeguimiento();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/*********************************************************************************/

/////////////////////////////////////////////////////////////////////////////
// CSaturateDlg static inizalitation

int     CSaturateDlg::threshold=100;
BOOL    CSaturateDlg::pasoApaso=FALSE;

/////////////////////////////////////////////////////////////////////////////
// CSaturateDlg dialog

CSaturateDlg::CSaturateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSaturateDlg::IDD, pParent),
  m_PasoApaso(pasoApaso),pDoc(NULL),pBWpic(NULL)
{
	//{{AFX_DATA_INIT(CSaturateDlg)
		// NOTE: the ClassWizard will add member initialization here
 	
	//}}AFX_DATA_INIT
}

BOOL CSaturateDlg::OnInitDialog() 
{
    CString Str;
    CSliderCtrl* pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_THERESHOLD);
    pSlider->SetRange(0, 300);
    pSlider->SetPos(threshold);
    int val = pSlider->GetPos();
    float percent;
    if (threshold > 100)
      percent = exp((double)threshold/100.0)/0.02718282;
    else 
      percent = float (threshold);
    Str.Format("Nivel de saturacin: %3.1f%%",percent);
    SetDlgItemText(IDC_STATIC_THRESHOLD, Str);

    return CDialog::OnInitDialog();
}

void CSaturateDlg::DoDataExchange(CDataExchange* pDX)
{ 
  /* if (pDX->m_bSaveAndValidate)==FALSE
   * Uptate local variables with persistent ones
   * and update dialog controls */
  if (!(pDX->m_bSaveAndValidate)) {
    m_PasoApaso=pasoApaso;

     ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD))
             ->SetPos(threshold);
    }

  CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CSaturateDlg)
    DDX_Check(pDX, IDC_PASO_A_PASO, m_PasoApaso);
	//}}AFX_DATA_MAP
    
  /* if (pDX->m_bSaveAndValidate)==TRUE
   * Uptate static variables with dialog values
   * For example, when OK button is pressed
   */
  if (pDX->m_bSaveAndValidate) {
    pasoApaso=m_PasoApaso;
    threshold = ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD))
             ->GetPos();
  }
}

BEGIN_MESSAGE_MAP(CSaturateDlg, CDialog)
	//{{AFX_MSG_MAP(CSaturateDlg)
	ON_BN_CLICKED(IDC_HELP_CANY, OnHelp)
	ON_BN_CLICKED(IDC_PASO_A_PASO,OnSeguimiento)
  ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSaturateDlg message handlers


void CSaturateDlg::OnHelp() 
{
  MessageBox("La ayuda no est todava a punto","Ayuda");
}

void CSaturateDlg::OnSeguimiento() 
{
  /* Update m_PasoApaso every time checkbox
   * is pressed */
  pasoApaso=m_PasoApaso=
    IsDlgButtonChecked(IDC_PASO_A_PASO);
}

void CSaturateDlg::OnHScroll(UINT nSBCode, UINT nPos,
                             CScrollBar* pScrollBar) 
{
  static BOOL Redrawing = FALSE ;
  CSliderCtrl* pSlide = (CSliderCtrl*) pScrollBar;    
  CString strText;
  int val = pSlide->GetPos();
  float percent;
  if (threshold > 100)
    percent = exp((double)val/100.0)/0.02718282;
  else 
    percent = float (val);
  strText.Format("Nivel de saturacin: %3.1f%%",percent);
  SetDlgItemText(IDC_STATIC_THRESHOLD, strText);
             
  if ( !Redrawing && m_PasoApaso ) { /* compute new image if it isn't yet */
    Redrawing = TRUE;
    /* Only compute new image if slider has changed since last time */
    if (val != threshold ) {
      threshold = val;
      ShowImageInBW ( threshold ) ;
    }
    /* The new image is computed and shown. Therefore, next
     * time the slider changes, a new image will be calculated
     */
    Redrawing = FALSE;
  }
}

/*********************************************************************************/
/* Show temporal image                                                           */
void CSaturateDlg::ShowImageInBW(int threshold)
{
  /* return if there is nothing to do! */
  if (!pDoc->pic || !pDoc->pWIDE ||
      !pDoc->pHIGH || pDoc->numcols == 2 ) return;

  float percent;
  if (threshold > 100)
    percent = exp((double)threshold/100.0)/0.02718282;
  else 
    percent = float (threshold);

  
  // Sature former image
  

    /*  generate a saturated version from 24 bits-RGB */
    if (pDoc->picType == PIC24)  {                             
        xvbcopy((char *) pDoc->pic, (char *) pBWpic, (size_t) (pDoc->pWIDE*pDoc->pHIGH*3));
        pDoc->saturePic24(pBWpic,pDoc->pWIDE,0,0,pDoc->pWIDE,pDoc->pHIGH,
          (float) percent/100.0 );
        pDoc->ShowImage(pBWpic,F_FULLCOLOR);
     }
    
    /*  generate a saturated version from colormapped image  */
    else if ( !pDoc->mono ) { /* ptype == PIC8 and not grayscaled */
           register byte maxv=0;
           int i;

           /* Normalize results */
           for (i=pDoc->numcols, maxv=0; i; ) {   /* compute max value in component*/
             i--;
             if (red[i]>maxv) maxv = red[i];
             if (green[i]>maxv) maxv = green[i];
             if (blue[i]>maxv) maxv = blue[i];
           }

           if (maxv>0) {
             float scale = (float) (((float) maxv)*100.0/percent);
             for (i=pDoc->numcols; i; ) {   /* compute max value in component*/
               i--;
               register int val;
               val = (int) pDoc->rMap[i]/scale;
               if (val>255) val=255;
               red[i] = val;
               val = (int) pDoc->gMap[i]/scale;
               if (val>255) val=255;
               green[i] = val;
               val = (int) pDoc->bMap[i]/scale;
               if (val>255) val=255;
               blue[i] = val;
             }
             pDoc->ShowImage(pDoc->pic,F_REDUCED,NULL,pDoc->pWIDE,
               pDoc->pHIGH,red,green,blue);
           }
        }
    /*  generate a BLACK & WHITE version from greyscaled image  */
    else { /* grayscaled image => faster conversion than colormaped one */
        xvbcopy((char *) pDoc->pic, (char *) pBWpic, (size_t) (pDoc->pWIDE*pDoc->pHIGH));
        pDoc->saturePicGrey(pBWpic,pDoc->pWIDE,0,0,pDoc->pWIDE,pDoc->pHIGH,
          (float) percent/100.0 );
        pDoc->ShowImage(pBWpic,F_GREYSCALE);
      }
}


/*********************************************************************************/
void CImgBasicDoc::Saturate (void) 
{
  /* Special tratament if image is being converted to black & white */

  /* return if there is nothing to do! */
  if (!pic || !pWIDE || !pHIGH || numcols == 2 ) return;
  /* allocate black & white image*/
  byte *pSave = (byte *) malloc((size_t) 
    ((picType == PIC24) ? (pWIDE*pHIGH*3):(pWIDE*pHIGH) ));
  if (!pSave) {
    Error("Ha fallado el alojamiento de la imagen");
    return;
  }

  /* Do interactive dialog for black & white level threshold
   * adjustement */
  CSaturateDlg dlg;
  dlg.pDoc = this;
  dlg.pBWpic = pSave;
  /* Show dialog */
  int button_pressed = dlg.DoModal();
  if (button_pressed == IDOK) {
    /* Instal BW version of image */
   //if (!dlg.pasoApaso) //Update Image is necesary.
      dlg.ShowImageInBW(dlg.threshold);
    int colormapped = (picType == PIC8) && (!mono);
    StoreNewPic(pSave,picType,mono,pWIDE,pHIGH,numcols,
      (colormapped) ? dlg.red : NULL, (colormapped) ? dlg.green : NULL,
      (colormapped) ? dlg.blue : NULL);
  } else { /* button_pressed == IDCANCEL */
   /* free memory and leave original image */
   free(pSave);
   /* update display with original image */
  }
  RedrawPic();
}