// diblook.cpp : Defines the class behaviors for the application.
//

/* Proyecto Fin de Carrera
 * Departamento de Informatica e Ingeniera de Sistemas
 * Universidad de Zaragora
 *
 * rea:      Robtica y Automatizacin Avanzada.
 * Tema:      Visin por Computador.
 * Ttulo:    Diseo de un entorno de visin para 
 *            el tratamiento de imgenes.
 * Director:  Dr. Carlos Sags Blzquiz.
 * Autor:     Joaqun Mur Amada.
 * Promocin: 1991-1996.
*/

#include "stdafx.h"
#include "VisioApp.h"

#include "mainfrm.h"
#include "dibdoc.h"
#include "dibview.h"
#include "Splash.h"
#include "ChildFrm.h"
#include "ImgDoc.h"
#include "ImgView.h"
#include "InspDoc.h"
#include "InspView.h"
#include "Filenewd.h"
#include "MultiFil.h"
#include "MeterBar.h"
#include "Multipad.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


static CString GetFileTypes();
// Max number of names in most recent used files list
#define N_MAX_MRU 10
/////////////////////////////////////////////////////////////////////////////
// CVisioApp

BEGIN_MESSAGE_MAP(CVisioApp, CWinApp)
	//{{AFX_MSG_MAP(CVisioApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
 	// MRU - most recently used file menu
 	ON_COMMAND_EX_RANGE(ID_FILE_MRU_FILE1, ID_FILE_MRU_FILE16, OnOpenRecentFile)
	//}}AFX_MSG_MAP
	// Standard file based document commands
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVisioApp construction
// Place all significant initialization in InitInstance

/////////////////////////////////////////////////////////////////////////////
// The one and only CVisioApp object

CVisioApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CDibLookApp initialization

BOOL CVisioApp::InitInstance()
{
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

  // CG: The following block was added by the Splash Screen component.
  // Show splash window if  no image is specified in command line
	CSplashWnd::EnableSplashScreen(cmdInfo.m_bShowSplash);

	// Standard initialization
	//  (if you are not using these features and wish to reduce the size
	// of your final executable, you should remove the following initialization

  // Use 3d controls in dialogs
#ifdef _AFXDLL
    Enable3dControls( );   // use shared CTL3D32.DLL
#else
    Enable3dControlsStatic( ); // function linked statically
#endif
  
  /* Load last main window position */
  SetRegistryKey("Joaquin_Mur");
  // Load standard INI file options (including MRU)
  LoadStdProfileSettings(N_MAX_MRU); // Load standar options from registry


	// Register document templates which serve as connection between
	//  documents and views.  Views are contained in the specified view

  m_pTemplateIOfile = new CMultiDocTemplate(IDR_DIBTYPE,
			RUNTIME_CLASS(CDibDoc),               // Document class
			RUNTIME_CLASS(CDibFrame),           // MDI child frame
			RUNTIME_CLASS(CDibView));             // View Class
	AddDocTemplate( m_pTemplateIOfile );          

  m_pTemplateImgBasic = new CMultiDocTemplate(IDR_IMGBASICTYPE,
			RUNTIME_CLASS(CImgBasicDoc),        // Document class
			RUNTIME_CLASS(CImgFrame),           // MDI child frame
			RUNTIME_CLASS(CImgBasicView));      // View Class
 	AddDocTemplate(m_pTemplateImgBasic);

  m_pTemplateInspection = new CMultiDocTemplate(IDR_INSPECTIONTYPE,
			RUNTIME_CLASS(CInspectionDoc),       // Document class
			RUNTIME_CLASS(CInspectionFrame),     // MDI child frame
			RUNTIME_CLASS(CInspectionView));     // View Class
	AddDocTemplate( m_pTemplateInspection ); 

  m_pTemplateTexto = new CMultiDocTemplate(IDR_TEXTTYPE,
		  RUNTIME_CLASS(CPadDoc),
      RUNTIME_CLASS(CPadFrame),
		  RUNTIME_CLASS(CPadView));
	AddDocTemplate( m_pTemplateTexto ); 
  
  /* Don't prompt for type of new files */
  m_nNewDocType = DOCTYPE_DEFAULT;
  m_bPromptForType = FALSE;

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
  if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
        return FALSE;
	m_pMainWnd = pMainFrame;

  pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	// enable file manager drag/drop and DDE Execute open
	m_pMainWnd->DragAcceptFiles();

	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	
  /* Ask display capabilities */
  {
    // Does the display need a palette to draw a 256-color bitmap?
    CDC* pDC=m_pMainWnd->GetDC();
    // Set CDibDoc static variable wich enforces the use of a palette
    // for displaying bitmaps
    CDibDoc::UsePalette = (RC_PALETTE | pDC->GetDeviceCaps(RASTERCAPS));
    m_pMainWnd->ReleaseDC(pDC);
  }

  // JOAKO
  // Don't Dispatch commands specified on the command line
	// Disable empty documents on application start if
  // no file name is given in command line
	//if (!ProcessShellCommand(cmdInfo))
	//	return FALSE;

  // Correction:  Allow open documents when the application is started
	// Dispatch commands specified on the command line
	if (cmdInfo.m_nShellCommand != CCommandLineInfo::FileNew &&
		  !ProcessShellCommand(cmdInfo)) {
    CSplashWnd::FinishedProgramLoad();
		return FALSE;}
  
  CSplashWnd::FinishedProgramLoad();
  m_bPromptForType = TRUE;

  /* the text window is not loaded at first */
  m_pPadView = NULL;

  return TRUE;
}


#ifdef _MAC

BOOL CVisioApp::CreateInitialDocument()
{
	// do *not* create a new (empty) document, but do return TRUE since no
	// failure occurred

	return TRUE;
}

#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg() : CDialog(CAboutDlg::IDD)
		{
			//{{AFX_DATA_INIT(CAboutDlg)
			//}}AFX_DATA_INIT
		}

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
		enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CVisioApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CVisioApp commands

BOOL CVisioApp::PreTranslateMessage(MSG* pMsg)
{
	// CG: The following line was added by the Splash Screen component.
	CSplashWnd::PreTranslateAppMessage(pMsg);

	return CWinApp::PreTranslateMessage(pMsg);
}

/////////////////////////////////////////////////////////////////////////////

void CVisioApp::OnFileOpen() 
{
	// prompt the user (with all document templates)
	CMultiFileDialog dlgFile(TRUE);
	CString title,strFilter,strDefault;
  int nIndex = m_nNewDocType, counter = 0;
  
  if ( nIndex<DOCTYPE_CDIBDOC || nIndex>DOCTYPE_LAST)
       nIndex = DOCTYPE_DEFAULT;
	
  VERIFY(title.LoadString(AFX_IDS_OPENFILE));
		
	// do for all doc template
	POSITION pos = GetFirstDocTemplatePosition();
	while (pos != NULL)
	{
		CDocTemplate* pTemplate = GetNextDocTemplate(pos);
		AppendFilterSuffix (strFilter, dlgFile.m_ofn, pTemplate,
			(counter == nIndex) ? &strDefault : NULL);
    counter++;
	}

	// append the "*.*" all files filter
	CString allFilter;
	VERIFY(allFilter.LoadString(AFX_IDS_ALLFILTER));
	strFilter += allFilter;
	strFilter += (TCHAR)'\0';   // next string please
	strFilter += _T("*.*");
	strFilter += (TCHAR)'\0';   // last string
	dlgFile.m_ofn.nMaxCustFilter++;

	dlgFile.m_ofn.lpstrFilter = strFilter;
	dlgFile.m_ofn.lpstrTitle = title;
	dlgFile.m_ofn.hwndOwner = AfxGetMainWnd()->GetSafeHwnd();
  dlgFile.m_ofn.Flags |= OFN_HIDEREADONLY | OFN_FILEMUSTEXIST 
                       | OFN_ALLOWMULTISELECT;
  //dlgFile.m_ofn.Flags &= ~OFN_SHOWHELP;
  nIndex++;
	dlgFile.m_ofn.nFilterIndex = nIndex;
	// strDefExt is necessary to hold onto the memory from GetExtFromType
	dlgFile.m_ofn.lpstrDefExt = strDefault;
  
	if (dlgFile.DoModal() == IDOK)
	{
 		m_nNewDocType = (int)dlgFile.m_ofn.nFilterIndex - 1;
    if ( m_nNewDocType<DOCTYPE_CDIBDOC ||
         m_nNewDocType>DOCTYPE_LAST)
     m_nNewDocType = DOCTYPE_DEFAULT;
    /*
    // search for the adecuate template
	  pos = GetFirstDocTemplatePosition();
    CDocTemplate* pTemplate;
	  for(int i=0; (pos != NULL) && i <= m_nNewDocType; i++ )
	  {
		  pTemplate = GetNextDocTemplate(pos);
	  }
    */
		pos = dlgFile.GetStartPosition();
		while (pos != NULL)
		{
			CString strPath = dlgFile.GetNextPathName(pos);
			if (strPath.Find(":\\\\") == 1 && strPath.GetLength() > 4)
			{
				// this means we have an invalid path that looks like this:
				// C:\\foo.bmp
				// We need to cut out the extra slash
				CString temp;
				temp = strPath.Left(3);
				temp += strPath.Mid(4);
				strPath = temp;
			}

      /*pTemplate->*/OpenDocumentFile(strPath);
		}
	}

}

/////////////////////////////////////////////////////////////////////////////

void CVisioApp::OnFileNew() 
{
  if (m_bPromptForType) {
    CFileNewDialog dlg;
    // search for the adecuate template
		if (dlg.DoModal() == IDCANCEL)
			return;
		m_nNewDocType = dlg.m_nSel;
    if ( m_nNewDocType<DOCTYPE_CDIBDOC || m_nNewDocType>DOCTYPE_LAST)
         m_nNewDocType = DOCTYPE_DEFAULT;
    dlg.m_pSelectedTemplate->OpenDocumentFile(NULL);
	}
  else {
    /*
	  POSITION pos = GetFirstDocTemplatePosition();
    CDocTemplate* pTemplate;
	  for(int i=0; (pos != NULL) && i <= m_nNewDocType; i++ )
	  {
		  pTemplate = GetNextDocTemplate(pos);
	  }
    pTemplate->OpenDocumentFile(NULL);
    */
    OpenDocumentFile(NULL);
  }
 
  /*
  switch (m_nNewDocType) {
  case DOCTYPE_CDIBDOC:
	    m_pTemplateIOfile->OpenDocumentFile(NULL);
      break;
  case DOCTYPE_CIMGBASICDOC:
	    m_pTemplateImgBasic->OpenDocumentFile(NULL);
      break;
  case DOCTYPE_CINSPECTIONDOC:
	    m_pTemplateInspection->OpenDocumentFile(NULL);
      break;
  }		// if returns NULL, the user has already been alerted
  */
}

/////////////////////////////////////////////////////////////////////////////
// MRU file list default implementation

BOOL CVisioApp::OnOpenRecentFile(UINT nID)
{
	ASSERT_VALID(this);
	ASSERT(m_pRecentFileList != NULL);

	ASSERT(nID >= ID_FILE_MRU_FILE1);
	ASSERT(nID < ID_FILE_MRU_FILE1 + (UINT)m_pRecentFileList->GetSize());
	int nIndex = nID - ID_FILE_MRU_FILE1;
	ASSERT((*m_pRecentFileList)[nIndex].GetLength() != 0);

	TRACE2("MRU: open file (%d) '%s'.\n", (nIndex) + 1,
			(LPCTSTR)(*m_pRecentFileList)[nIndex]);
  if (m_bPromptForType) {
    CFileNewDialog dlg;
    // search for the adecuate template
		if (dlg.DoModal() == IDCANCEL)
			return FALSE;
		m_nNewDocType = dlg.m_nSel;
    if ( m_nNewDocType<DOCTYPE_CDIBDOC || m_nNewDocType>DOCTYPE_LAST)
         m_nNewDocType = DOCTYPE_DEFAULT;
	  if (dlg.m_pSelectedTemplate->OpenDocumentFile((*m_pRecentFileList)[nIndex])
                            == NULL)
		  m_pRecentFileList->Remove(nIndex);
  } else {
	  if (OpenDocumentFile((*m_pRecentFileList)[nIndex]) == NULL)
		  m_pRecentFileList->Remove(nIndex);
  }
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////

CDocument* CVisioApp::OpenDocumentFile(LPCTSTR lpszFileName)
{
	//ASSERT(m_pDocManager != NULL);
	POSITION pos = GetFirstDocTemplatePosition();
  CDocTemplate* pTemplate;
	for(int i=0; (pos != NULL) && i <= m_nNewDocType; i++ )
	{
		pTemplate = GetNextDocTemplate(pos);
	}
  ASSERT(pTemplate != NULL);
  return pTemplate->OpenDocumentFile(lpszFileName);
}

/////////////////////////////////////////////////////////////////////////////
CPadView* CVisioApp::GetTextView()
{
  /* returns current text window and creates one new if
   * none is available. Returns NULL on error */
  // Get the text document
  if ( m_pPadView == NULL) {
    POSITION pos = m_pTemplateTexto->GetFirstDocPosition();
    CPadDoc* pTextDocument = NULL;
    if (pos != NULL) 
      pTextDocument = (CPadDoc*) m_pTemplateTexto->GetNextDoc(pos);
    if (pTextDocument == NULL) {
      /* No text document is available */
      pTextDocument = (CPadDoc*) m_pTemplateTexto->OpenDocumentFile(NULL);
      LONG ntimes=50; // Let time to create the view
      OnIdle(ntimes); 
      pTextDocument->SetTitle("Output");
      POSITION pos = pTextDocument->GetFirstViewPosition();
      while (pos != NULL)
      {
          CView* pView = pTextDocument->GetNextView(pos);
          CFrameWnd* pWnd = (CMDIChildWnd*) pView->GetParentFrame();
          TRACE("Ventana OUTPUT minimizada");
          if (  pWnd != NULL ) {
            WINDOWPLACEMENT lpwndpl;
            pWnd->GetWindowPlacement( &lpwndpl ) ;
            lpwndpl.showCmd = SW_MINIMIZE;
            pWnd->SetWindowPlacement( &lpwndpl ) ;
          };
       }
    }
    if (pTextDocument == NULL) {
      AfxMessageBox("No puedo crear un documento de texto en la funcin 'GetTextView'");
      return NULL;
    }
    m_pPadView = pTextDocument->GetView();
    if (m_pPadView == NULL) {
      AfxMessageBox("No puedo crear una vista de texto en la funcin 'GetTextView'");
      return NULL;
    } 
  }
  ASSERT_VALID(m_pPadView);
  return m_pPadView;
}

int CVisioApp::printf(const char *format, ...)
{
  va_list arglist;
  int retval;
  va_start(arglist,format);
  retval = GetTextView()->vprintf(format,arglist); 
  va_end(arglist);
  return retval;
}

int CVisioApp::scanf (const char *format, ...)
{
  va_list arglist;
  int retval;
  va_start(arglist,format);
  retval = GetTextView()->vscanf(format,arglist); 
  va_end(arglist);
  return retval;
}

/////////////////////////////////////////////////////////////////////////////

static CString GetFileTypes()
{
	CString str, strFile, strSub;
	
  VERIFY(strFile.LoadString(IDS_VISUALIZATION));
  strSub = "";
	AfxExtractSubString(strSub, strFile,CDocTemplate::fileNewName);
  str += strSub;
	str += (TCHAR)NULL;
  strSub = "";
  AfxExtractSubString(strSub, strFile, CDocTemplate::filterExt);
  str += strSub;
	str += (TCHAR)NULL;
  
  VERIFY(strFile.LoadString(IDS_PROCESAMIENTO_BASICO));
  strSub = "";
	AfxExtractSubString(strSub, strFile,CDocTemplate::fileNewName);
  str += strSub;
	str += (TCHAR)NULL;
  strSub = "";
  AfxExtractSubString(strSub, strFile, CDocTemplate::filterExt);
  str += strSub;
	str += (TCHAR)NULL;

  VERIFY(strFile.LoadString(IDS_INSPECTION));
  strSub = "";
	AfxExtractSubString(strSub, strFile,CDocTemplate::fileNewName);
  str += strSub;
	str += (TCHAR)NULL;
  strSub = "";
  AfxExtractSubString(strSub, strFile, CDocTemplate::filterExt);
	str += (TCHAR)NULL;

	return str;
}


// prompt for file name - used for open and save as
// static function called from app
BOOL CVisioApp::PromptForFileName(CString& fileName, UINT nIDSTitle, 
	DWORD dwFlags, BOOL bOpenFileDialog, int* pType)
{
	CFileDialog dlgFile(bOpenFileDialog);
	CString title;

	VERIFY(title.LoadString(nIDSTitle));
	
	dlgFile.m_ofn.Flags |= dwFlags;
//	dlgFile.m_ofn.Flags &= ~OFN_SHOWHELP;

	int nIndex = m_nNewDocType;
	if (!bOpenFileDialog)
	{
		nIndex = (pType != NULL) ? *pType : DOCTYPE_DEFAULT;
    if ( nIndex<DOCTYPE_CDIBDOC || nIndex>DOCTYPE_LAST)
         nIndex = DOCTYPE_DEFAULT;
		nIndex++;
	}
	dlgFile.m_ofn.nFilterIndex = nIndex;
	// strDefExt is necessary to hold onto the memory from GetExtFromType
	dlgFile.m_ofn.lpstrDefExt = NULL;
		
  CString strFilter = GetFileTypes();
	dlgFile.m_ofn.lpstrFilter = strFilter;
	dlgFile.m_ofn.lpstrTitle = title;
	dlgFile.m_ofn.lpstrFile = fileName.GetBuffer(_MAX_PATH);

	BOOL bRet = (dlgFile.DoModal() == IDOK) ? TRUE : FALSE;
	fileName.ReleaseBuffer();
	if (bRet)
	{
		if (pType != NULL)
		{
			nIndex = (int)dlgFile.m_ofn.nFilterIndex - 1;
			ASSERT(nIndex >= 0);
			*pType = nIndex;
		}
	}
	return bRet;
}

// taken directly from mfc\src\docmgr.cpp
void AppendFilterSuffix(CString& filter, OPENFILENAME& ofn,
	CDocTemplate* pTemplate, CString* pstrDefaultExt)
{
	ASSERT_VALID(pTemplate);
	ASSERT_KINDOF(CDocTemplate, pTemplate);

	CString strFilterExt, strFilterName;
	if (pTemplate->GetDocString(strFilterExt, CDocTemplate::filterExt) &&
		!strFilterExt.IsEmpty() &&
		pTemplate->GetDocString(strFilterName, CDocTemplate::filterName) &&
		!strFilterName.IsEmpty())
	{
		// a file based document template - add to filter list
		ASSERT(strFilterExt[0] == '.');
		if ( pstrDefaultExt != NULL)
		{
			// set the default extension
			*pstrDefaultExt = ((LPCTSTR)strFilterExt) + 1;  // skip the '.'
			ofn.lpstrDefExt = (LPTSTR)(LPCTSTR)(*pstrDefaultExt);
			ofn.nFilterIndex = ofn.nMaxCustFilter + 1;  // 1 based number
		}

		// add to filter
		filter += strFilterName;
		ASSERT(!filter.IsEmpty());  // must have a file type name
		filter += (TCHAR)'\0';  // next string please
		filter += (TCHAR)'*';
		filter += strFilterExt;
		filter += (TCHAR)'\0';  // next string please
		ofn.nMaxCustFilter++;
	}
}

