// Visio.h : main header file for application VISIO
//

#ifndef _VISIO_H_
#define _VISIO_H_

/* Proyecto Fin de Carrera
 * Departamento de Informatica e Ingeniera de Sistemas
 * Universidad de Zaragora
 *
 * rea:      Robtica y Automatizacin Avanzada.
 * Tema:      Visin por Computador.
 * Ttulo:    Diseo de un entorno de visin para 
 *            el tratamiento de imgenes.
 * Director:  Dr. Carlos Sags Blzquiz.
 * Autor:     Joaqun Mur Amada.
 * Promocin: 1991-1996.
*/

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "..\res\resource.h"           // main symbols

// User's messages
#define WM_DOREALIZE   (WM_USER + 0)
#define WM_ENDCAPTURE  (WM_USER + 1)

// Document Types
#define DOCTYPE_UNKNOWN       -1
#define DOCTYPE_CDIBDOC        0
#define DOCTYPE_CIMGBASICDOC   1
#define DOCTYPE_CINSPECTIONDOC 2
#define DOCTYPE_TEXT           3
#define DOCTYPE_LAST           3
#define DOCTYPE_DEFAULT       DOCTYPE_CIMGBASICDOC

/////////////////////////////////////////////////////////////////////////////
// CVisioApp:
// See diblook.cpp for the implementation of this class
//

class CPadView;

class CVisioApp : public CWinApp
{
// Attributes (Data members)
public:
  int m_nNewDocType;
	BOOL m_bPromptForType;
  CMultiDocTemplate *m_pTemplateTexto;
  CMultiDocTemplate *m_pTemplateIOfile;
  CMultiDocTemplate *m_pTemplateImgBasic;
  CMultiDocTemplate *m_pTemplateInspection;
  CPadView* m_pPadView;

public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
  
  //Operations
public:
	BOOL PromptForFileName(CString& fileName, UINT nIDSTitle, DWORD dwFlags,
		                     BOOL bOpenFileDialog, int* pType = NULL);
  //overrided to open in correct mode selon m_bPrompForType && m_nNewDocType
	virtual CDocument* OpenDocumentFile(LPCTSTR lpszFileName); // open named file
  CPadView* GetTextView();
  int printf(const char *format, ...);
  int scanf (const char *format, ...);

// Overrides
	virtual BOOL InitInstance();
#ifdef _MAC
	virtual BOOL CreateInitialDocument();
#endif

// Implementation

	//{{AFX_MSG(CVisioApp)
	afx_msg void OnAppAbout();
 	afx_msg void OnFileNew();
	afx_msg void OnFileOpen();
 	afx_msg BOOL OnOpenRecentFile(UINT nID);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

void AppendFilterSuffix(CString& filter, OPENFILENAME& ofn,
	CDocTemplate* pTemplate, CString* pstrDefaultExt);

/////////////////////////////////////////////////////////////////////////////

#endif // _VISIO_H_